/*
	Perapera-kun
	Justin Kovalchuk
	http://perapera.wordpress.com/
	
	---
	
	Based on Rikaichan by Jonathan Zarate
	Copyright (C) 2005-2009 
	http://www.polarcloud.com/
	
	---

	This program is free software; you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation; either version 2 of the License, or
	(at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

	---

	Please do not change or remove any of the copyrights or links to web pages
	when modifying any of the files. - Jon

*/

function chnDict(loadNames) {
	var hWindow = Components.classes["@mozilla.org/appshell/appShellService;1"]
				.getService(Components.interfaces.nsIAppShellService)
				.hiddenDOMWindow;

	if (hWindow.perakun_dict) {
		hWindow.perakun_dict.lock();
		return hWindow.perakun_dict;
	}

	this.loadDictionary();

	this.lock();
	this.hWindow = hWindow;
	hWindow.perakun_dict = this;
}

chnDict.prototype = {

	lockCount: 0,

	miniHelp:
		'<span style="font-weight:bold">Chinese Perapera-kun enabled!</span><br><br>' +
		'<table cellspacing=5>' +
		'<tr><td>A&nbsp;&nbsp;&nbsp;</td><td>Alternate popup location</td></tr>' +
		'<tr><td>Y&nbsp;&nbsp;&nbsp;</td><td>Move popup location down</td></tr>' +
		'<tr><td>C&nbsp;&nbsp;&nbsp;</td><td>Copy to clipboard</td></tr>' +
		'<tr><td>S&nbsp;&nbsp;&nbsp;</td><td>Save to Wordlist</td></tr>' +
		//'<tr><td>Shift/Enter&nbsp;&nbsp;</td><td>Switch dictionaries</td></tr>' +
		'<tr><td>B&nbsp;&nbsp;&nbsp;</td><td>Previous character</td></tr>' +
		'<tr><td>M&nbsp;&nbsp;&nbsp;</td><td>Next character</td></tr>' +
		'<tr><td>N&nbsp;&nbsp;&nbsp;</td><td>Next word</td></tr>' +
		'</table>',
		
	lock: function() {
		++this.lockCount;
	},

	unlock: function() {
		if (--this.lockCount == 0) {
			delete this.hWindow.perakun_dict;
		}
	},

	//

	config: {},

	setConfig: function(c) {
		this.config = c;
	},

	//

	fileRead: function(url, charset) {
		var ss;
		var inp;
		var buffer;
		var conv;

		ss = Components.classes['@mozilla.org/scriptableinputstream;1']
				.getService(Components.interfaces.nsIScriptableInputStream);
		inp = Components.classes['@mozilla.org/network/io-service;1']
				.getService(Components.interfaces.nsIIOService)
				.newChannel(url, null, null)
				.open();
		ss.init(inp);
		buffer = ss.read(inp.available());
		ss.close();
		inp.close();
		if (!charset) return buffer;

		conv = Components.classes['@mozilla.org/intl/scriptableunicodeconverter']
					.createInstance(Components.interfaces.nsIScriptableUnicodeConverter);
		conv.charset = charset;
		return conv.ConvertToUnicode(buffer);
	},

	fileReadArray: function(name, charset) {
		var a = this.fileRead(name, charset).split('\n');
		while ((a.length > 0) && (a[a.length - 1].length == 0)) a.pop();
		return a;
	},

	find: function(data, text) {
		const tlen = text.length;
		var beg = 0;
		var end = data.length - 1;
		var i;
		var mi;
		var mis;

		while (beg < end) {
			mi = (beg + end) >> 1;
			i = data.lastIndexOf('\n', mi) + 1;

			mis = data.substr(i, tlen);
			if (text < mis) end = i - 1;
				else if (text > mis) beg = data.indexOf('\n', mi + 1) + 1;
					else return data.substring(i, data.indexOf('\n', mi + 1));
		}
		return null;
	},

	//

	//	Note: These are mostly flat text files; loaded as one continous string to reduce memory use
	loadDictionary: function() {
		this.wordDict = this.fileRead(ppkChineseDict.datURI, ppkChineseDict.datCharset);
		this.wordIndex = this.fileRead(ppkChineseDict.idxURI, ppkChineseDict.idxCharset);
	},

  formatPinyin: function( pinyin ){
    //pinyin info
    var _a = [ "\u0101", "\u00E1", "\u01CE", "\u00E0", "a"];
    var _e = [ "\u0113", "\u00E9", "\u011B", "\u00E8", "e"];
    var _i = [ "\u012B", "\u00ED", "\u01D0", "\u00EC", "i"];
    var _o = [ "\u014D", "\u00F3", "\u01D2", "\u00F2", "o"];
    var _u = [ "\u016B", "\u00FA", "\u01D4", "\u00F9", "u"];
    var _v = [ "\u01D6", "\u01D8", "\u01DA", "\u01DC", "\u00FC"];

    pinyin = pinyin.split(" ");
    for( j = 0; j < pinyin.length; j++){
    	pin = pinyin[j];
    	tone = 4;

    	if( pin.indexOf("1") != -1 ) tone = 0;
    	else if( pin.indexOf("2") != -1 ) tone = 1;
    	else if( pin.indexOf("3") != -1 ) tone = 2;
    	else if( pin.indexOf("4") != -1 ) tone = 3;
    	
    	if( pin.indexOf("a") != -1 ) pin = pin.replace( "a", _a[tone] );
    	else if( pin.indexOf("e") != -1 ) pin = pin.replace( "e", _e[tone] );
    	else if( pin.indexOf("ou") != -1 ) pin = pin.replace( "o", _o[tone] );
    	else {
    	 for( k = pin.length - 1; k >= 0; k--){
    		if( this.isVowel(pin[k]) ){
    			switch(pin[k]){
    			 case 'i':  pin = pin.replace( "i", _i[tone] ); break;
    			 case 'o':  pin = pin.replace( "o", _o[tone] ); break;
    			 case 'u':  if( k+1 < pin.length - 1 && pin[k+1] == ":" ) pin = pin.replace( "u:", _v[tone] ); 
    				     else pin = pin.replace( "u", _u[tone] ); break;
    			 default: alert("some kind of wierd vowel");
    			}
    		break;
    		}
    	 }
      }
    pinyin[j] = pin.substring(0, pin.length - 1);//strip the number
    }
   return pinyin.join(" ");
  },
  
  isVowel: function( letter ){
    if( letter == "a" || letter == "e" || letter == "i" ||
        letter == "o" || letter == "u" ) return true;
    else return false; 
  },
  
  	shitSearch: function( book, word)
	{
		var params = {};
		params.isSimp = false;

	    fi = book.indexOf( "\n" + word + ",");
	    if( fi != -1 ) //traditional match
	    {
	    	var lineStart = book.lastIndexOf("\n", fi+1) + 1;
			var lineEnd = book.indexOf("\r", fi+1);
			
			var line = book.substr(lineStart, lineEnd-lineStart);
			var entries = line.split(";");
			params.linecodes = entries[1];
			
			var chinese = entries[0].split(",")
			if(chinese[0].trim() == chinese[1].trim()) //trad is same as simp so there could be more simp matches
			{
				fi = book.indexOf( "," + word + ";");
				while(fi != -1)
				{
					params.isSimp = true;
					lineStart = book.lastIndexOf("\n", fi+1) + 1;
					lineEnd = book.indexOf("\r", fi+1);
					line = book.substr(lineStart, lineEnd-lineStart);
					entries = line.split(";");
					if(params.linecodes.indexOf(entries[1]) == -1)
						params.linecodes += "," + entries[1];
					fi = book.indexOf( "," + word + ";", lineEnd + 1);
				}
			}
	    }
	    else //simplified match
	    {
	    	fi = book.indexOf( "," + word + ";");
	    	params.isSimp = true;
		    if( fi == -1 ) 
				return -1;
			else
			{
				var lineStart = book.lastIndexOf("\n", fi+1) + 1;
				var lineEnd = book.indexOf("\r", fi+1);
				var line = book.substr(lineStart, lineEnd-lineStart);
				var entries = line.split(";");
				params.linecodes = entries[1];
				fi = book.indexOf( "," + word + ";", lineEnd + 1);
				while(fi != -1)
				{
					lineStart = book.lastIndexOf("\n", fi+1) + 1;
					lineEnd = book.indexOf("\r", fi+1);
					line = book.substr(lineStart, lineEnd-lineStart);
					entries = line.split(";");
					params.linecodes += "," + entries[1];
					fi = book.indexOf( "," + word + ";", lineEnd + 1);
				}
			}
	    }
	    return params;
	},
	
	dissectCCEDICT: function(entry){
		
		var params = {};
		var space1 = entry.indexOf(" ");
		var space2 = entry.indexOf(" ", space1 + 1);
		var bracket1 = entry.indexOf("[");
		var bracket2 = entry.indexOf("]");
		var slash1 = entry.indexOf("/");
		var slash2 = entry.lastIndexOf("/");
		
		params.trad = entry.substr(0, space1);
		params.simp = entry.substr(space1 + 1, space2 - space1 - 1);
		params.pinyin = this.formatPinyin( entry.substr(bracket1 + 1, bracket2 - bracket1 - 1) );
		params.def = entry.substr(slash1 + 1, slash2 - slash1 - 1);
		
		return params;
	},
	
	inLanguageRange: function(u)
	{
		if( (u < 0x4E00) || (u > 0x9FFF) )
			return false;
		else
			return true;
	},
	
   wordSearch: function(word, doNames, max)
   {
  
	var rs;
    var pinyin;
    var def;
	var entries = "";
	var prefs = Components.classes["@mozilla.org/preferences-service;1"]
				.getService(Components.interfaces.nsIPrefService)
				.getBranch("perakun."); 
    	
	var entry = { };
	entry.data = [];
	var results = [];
	var params;
	maxlen = 0;
    found = false;
    
    var isSimp;
    var firstfound = true;
    
    pos = 0; //position in file for multiple searches
	
	
	while( word.length > 0 )
	{
		
        params = this.shitSearch(this.wordIndex, word);
        if(!params || !params.linecodes)
        {
        	word = word.substring(0, word.length - 1);
        	continue;
        }
        else
        {
        	if(firstfound) //this is ensure we dont flip later if the last char is the same trad and simp
        	{
        		isSimp = params.isSimp;
        		firstfound = false;
        	}
	        var indexes = params.linecodes.split(",");
			for(i = 0; i < indexes.length; i++)
			{
				var theIndex = parseInt(indexes[i]);
				if( theIndex > this.wordDict.length )
				{ 
					alert("dictionary index error, tried to pull entry " + theIndex + " from an array size of " & this.wordDict.length );
		        	return -1;
		        }
		        var theLength = this.wordDict.indexOf("\n", theIndex+1) - theIndex;
		        var theEntry = this.wordDict.substr( theIndex, theLength  );
		        //alert(theIndex + "\n" + theLength + "\n" + theEntry);
				results.push( theEntry );
			}
		    word = word.substring(0, word.length - 1);
        }
    }
	var maxlen = 0;
    for( i = 0; i < results.length; i++ )
	{
    	
		var current = results[i].toString();
		var ent = this.dissectCCEDICT(results[i]);
		if(ent.simp.length > maxlen)
			maxlen = ent.simp.length;
		var theEntry = "";
		switch(prefs.getIntPref('chndisp'))
		{
			case 0: //As Displayed
			theEntry = (isSimp == true ? ent.simp : ent.trad) + " [" + ent.pinyin + "] /" + ent.def + "/";
			break;
			case 1: //Only Simplified
			theEntry = ent.simp + " [" + ent.pinyin + "] /" + ent.def + "/";
			break;
			case 2: //Only Traditional
			theEntry = ent.trad + " [" + ent.pinyin + "] /" + ent.def + "/";
			break;
			case 3: //Both
			theEntry = ent.trad + " " + ent.simp + " [" + ent.pinyin + "] /" + ent.def + "/";
			break;
		}
		//alert(tempers);
		entry.data.push([theEntry, null]);
    }
    entry.matchLen = maxlen;
    return entry;
  },

	translate: function(text) {
		var e, o;
		var skip;

		o = {};
		o.data = [];
		o.textLen = text.length;

		while (text.length > 0) {
			e = this.wordSearch(text, false, 1);
			if (e != null) {
				if (o.data.length >= this.config.wmax) {
					o.more = 1;
					break;
				}
//				o.data = o.data.concat(e.data);
				o.data.push(e.data[0]);
				skip = e.matchLen;
			}
			else {
				skip = 1;
			}
			text = text.substr(skip, text.length - skip);
		}

		if (o.data.length == 0) {
			return null;
		}

		o.textLen -= text.length;
		return o;
	},

	makeHtml: function(entry) {
		var e;
		var b;
		var c, s, t;
		var i, j, n;

		if (entry == null) return '';

		b = [];

		if (entry.kanji) {
			var yomi;
			var box;
			var bn;
			var k;
			var nums;

			yomi = entry.onkun.replace(/\.([^\u3001]+)/g, '<span class="k-yomi-hi">$1</span>');
			if (entry.nanori.length) {
				yomi += '<br/><span class="k-yomi-ti">\u540D\u4E57\u308A</span> ' + entry.nanori;
			}
			if (entry.bushumei.length) {
				yomi += '<br/><span class="k-yomi-ti">\u90E8\u9996\u540D</span> ' + entry.bushumei;
			}

			bn = entry.misc['B'] - 1;
			k = entry.misc['G'];
			switch (k) {
			case 8:
				k = 'general<br/>use';
				break;
			case 9:
				k = 'name<br/>use';
				break;
			default:
				k = isNaN(k) ? '-' : ('grade<br/>' + k);
				break;
			}
			box = '<table class="k-abox-tb"><tr>' +
				'<td class="k-abox-r">radical<br/>' + this.radData[bn].charAt(0) + ' ' + (bn + 1) + '</td>' +
				'<td class="k-abox-g">' + k + '</td>' +
				'</tr><tr>' +
				'<td class="k-abox-f">freq<br/>' + (entry.misc['F'] ? entry.misc['F'] : '-') + '</td>' +
				'<td class="k-abox-s">strokes<br/>' + entry.misc['S'] + '</td>' +
				'</tr></table>';
			if (this.config.kdisp['COMP'] == 1) {
				k = this.radData[bn].split('\t');
				box += '<table class="k-bbox-tb">' +
						'<tr><td class="k-bbox-1a">' + k[0] + '</td>' +
						'<td class="k-bbox-1b">' + k[2] + '</td>' +
						'<td class="k-bbox-1b">' + k[3] + '</td></tr>';
				j = 1;
				for (i = 0; i < this.radData.length; ++i) {
					s = this.radData[i];
					if ((bn != i) && (s.indexOf(entry.kanji) != -1)) {
						k = s.split('\t');
						c = ' class="k-bbox-' + (j ^= 1);
						box += '<tr><td' + c + 'a">' + k[0] + '</td>' +
								'<td' + c + 'b">' + k[2] + '</td>' +
								'<td' + c + 'b">' + k[3] + '</td></tr>';
					}
				}
				box += '</table>';
			}

			nums = '';
			j = 0;

			for (i = 0; i < this.numList.length; i += 2) {
				c = this.numList[i];
				if (this.config.kdisp[c] == 1) {
					s = entry.misc[c];
					c = ' class="k-mix-td' + (j ^= 1) + '"';
					nums += '<tr><td' + c + '>' + this.numList[i + 1] + '</td><td' + c + '>' + (s ? s : '-') + '</td></tr>';
				}
			}
			if (nums.length) nums = '<table class="k-mix-tb">' + nums + '</table>';

			b.push('<table class="k-main-tb"><tr><td valign="top">');
			b.push(box);
			b.push('<span class="k-kanji">' + entry.kanji + '</span><br/>');
			b.push('<div class="k-eigo">' + entry.eigo + '</div>');
			b.push('<div class="k-yomi">' + yomi + '</div>');
			b.push('</td></tr><tr><td>' + nums + '</td></tr></table>');
			return b.join('');
		}

		s = t = '';

		if (entry.names) {
			c = [];

			b.push('<div class="w-title">Names Dictionary</div><table class="w-na-tb"><tr><td>');
			for (i = 0; i < entry.data.length; ++i) {
				e = entry.data[i][0].match(/^(.+?)\s+(?:\[(.*?)\])?\s*\/(.+)\//);
				if (!e) continue;

				if (s != e[3]) {
					c.push(t);
					t = '';
				}

				if (e[2]) c.push('<span class="w-kanji">' + e[1] + '</span>&#32;<span class="w-kana">' + e[2] + '</span><br/> ');
					else c.push('<span class="w-kana">' + e[1] + '</span><br/> ');

				s = e[3];
				t = '<span class="w-def">' + s.replace(/\//g, '; ') + '</span><br/>';
			}
			c.push(t);
			if (c.length > 4) {
				n = (c.length >> 1) + 1;
				b.push(c.slice(0, n + 1).join(''));

				t = c[n];
				c = c.slice(n, c.length);
				for (i = 0; i < c.length; ++i) {
					if (c[i].indexOf('w-def') != -1) {
						if (t != c[i]) b.push(c[i]);
						if (i == 0) c.shift();
						break;
					}
				}

				b.push('</td><td>');
				b.push(c.join(''));
			}
			else {
				b.push(c.join(''));
			}
			if (entry.more) b.push('...<br/>');
			b.push('</td></tr></table>');
		}
		else {
			if (entry.title) {
				b.push('<div class="w-title">' + entry.title + '</div>');
			}

			var pK = '';
			var k;

			for (i = 0; i < entry.data.length; ++i) {
				e = entry.data[i][0].match(/^(.+?)\s+(?:\[(.*?)\])?\s*\/(.+)\//);
				if (!e) continue;

				/*
					e[1] = kanji/kana
					e[2] = kana
					e[3] = definition
				*/

				if (s != e[3]) {
					b.push(t);
					pK = k = '';
				}
				else {
					k = t.length ? '<br/>' : '';
				}

				if (e[2]) {
					if (pK == e[1]) k = '\u3001 <span class="w-kana">' + e[2] + '</span>';
						else k += '<span class="w-kanji">' + e[1] + '</span> &#32; <span class="w-kana">' + e[2] + '</span>';
					pK = e[1];
				}
				else {
					k += '<span class="w-kana">' + e[1] + '</span>';
					pK = '';
				}
				b.push(k);

				if (entry.data[i][1]) b.push(' <span class="w-conj">(' + entry.data[i][1] + ')</span>');

				s = e[3];
				t = s.replace(/\//g, '; ');
				if (!this.config.wpos) t = t.replace(/^\([^)]+\)\s*/, '');
				if (!this.config.wpop) t = t.replace('; (P)', '');
				t = '<br/><span class="w-def">' + t + '</span><br/>';
			}
			b.push(t);
			if (entry.more) b.push('...<br/>');
		}

		return b.join('');
	},


	makeHtmlForRuby: function(entry) {
		var e;
		var b;
		var c, s, t;
		var i, j, n;

		if (entry == null) return '';

		b = [];

		s = t = '';

		if (entry.title) {
			b.push('<div class="w-title">' + entry.title + '</div>');
		}

		for (i = 0; i < entry.data.length; ++i) {
			e = entry.data[i][0].match(/^(.+?)\s+(?:\[(.*?)\])?\s*\/(.+)\//);
			if (!e) continue;

			s = e[3];
			t = s.replace(/\//g, '; ');
			if (!this.config.wpos) t = t.replace(/^\([^)]+\)\s*/, '');
			if (!this.config.wpop) t = t.replace('; (P)', '');
			t = '<span class="w-def">' + t + '</span><br/>\n';
		}
		b.push(t);

		return b.join('');
	},

	makeText: function(entry, max) {
		var e;
		var b;
		var i, j;
		var t;

		if (entry == null) return '';

		b = [];

		if (entry.kanji) {
			b.push(entry.kanji + '\n');
			b.push((entry.eigo.length ? entry.eigo : '-') + '\n');

			b.push(entry.onkun.replace(/\.([^\u3001]+)/g, '\uFF08$1\uFF09') + '\n');
			if (entry.nanori.length) {
				b.push('\u540D\u4E57\u308A\t' + entry.nanori + '\n');
			}
			if (entry.bushumei.length) {
				b.push('\u90E8\u9996\u540D\t' + entry.bushumei + '\n');
			}

			for (i = 0; i < this.numList.length; i += 2) {
				e = this.numList[i];
				if (this.config.kdisp[e] == 1) {
					j = entry.misc[e];
					b.push(this.numList[i + 1].replace('&amp;', '&') + '\t' + (j ? j : '-') + '\n');
				}
			}
		}
		else {
			if (max > entry.data.length) max = entry.data.length;
			for (i = 0; i < max; ++i) {
				e = entry.data[i][0].match(/^(.+?)\s+(?:\[(.*?)\])?\s*\/(.+)\//);
				if (!e) continue;

				if (e[2]) {
					b.push(e[1] + '\t' + e[2]);
				}
				else {
					b.push(e[1]);
				}

				t = e[3].replace(/\//g, '; ');
				if (!this.config.wpos) t = t.replace(/^\([^)]+\)\s*/, '');
				if (!this.config.wpop) t = t.replace('; (P)', '');
				b.push('\t' + t + '\n');
			}
		}
		return b.join('');
	}
};
