/*
	Perapera-kun
	Justin Kovalchuk
	http://perapera.wordpress.com/
	
	---
	
	Based on Rikaichan by Jonathan Zarate
	Copyright (C) 2005-2009 
	http://www.polarcloud.com/
	
	---

	This program is free software; you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation; either version 2 of the License, or
	(at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

	---

	Please do not change or remove any of the copyrights or links to web pages
	when modifying any of the files. - Jon

*/

function korDict(loadNames) {
	var hWindow = Components.classes["@mozilla.org/appshell/appShellService;1"]
				.getService(Components.interfaces.nsIAppShellService)
				.hiddenDOMWindow;

	if (hWindow.perakun_dict) {
		hWindow.perakun_dict.lock();
		return hWindow.perakun_dict;
	}

	this.loadDictionary();

	this.lock();
	this.hWindow = hWindow;
	hWindow.perakun_dict = this;
}

korDict.prototype = {

	lockCount: 0,

	miniHelp:
		'<span style="font-weight:bold">Korean Perapera-kun enabled!</span><br /><br />' +
		'<table cellspacing=5>' +
		'<tr><td>A&nbsp;&nbsp;&nbsp;</td><td>Alternate popup location</td></tr>' +
		'<tr><td>Y&nbsp;&nbsp;&nbsp;</td><td>Move popup location down</td></tr>' +
		//'<tr><td>C</td><td>Copy to clipboard</td></tr>' +
		//'<tr><td>S</td><td>Save to Wordlist</td></tr>' +
		//'<tr><td>Shift/Enter&nbsp;&nbsp;</td><td>Switch dictionaries</td></tr>' +
		//'<tr><td>B</td><td>Previous character</td></tr>' +
		//'<tr><td>M</td><td>Next character</td></tr>' +
		//'<tr><td>N</td><td>Next word</td></tr>' +
		'</table>',
		
	lock: function() {
		++this.lockCount;
	},

	unlock: function() {
		if (--this.lockCount == 0) {
			delete this.hWindow.perakun_dict;
		}
	},

	//

	config: {},

	setConfig: function(c) {
		this.config = c;
	},

	//

	fileRead: function(url, charset) {
		var ss;
		var inp;
		var buffer;
		var conv;

		ss = Components.classes['@mozilla.org/scriptableinputstream;1']
				.getService(Components.interfaces.nsIScriptableInputStream);
		inp = Components.classes['@mozilla.org/network/io-service;1']
				.getService(Components.interfaces.nsIIOService)
				.newChannel(url, null, null)
				.open();
		ss.init(inp);
		buffer = ss.read(inp.available());
		ss.close();
		inp.close();
		if (!charset) return buffer;

		conv = Components.classes['@mozilla.org/intl/scriptableunicodeconverter']
					.createInstance(Components.interfaces.nsIScriptableUnicodeConverter);
		conv.charset = charset;
		return conv.ConvertToUnicode(buffer);
	},

	fileReadArray: function(name, charset) {
		var a = this.fileRead(name, charset).split('\n');
		while ((a.length > 0) && (a[a.length - 1].length == 0)) a.pop();
		return a;
	},

	find: function(data, text) {
		const tlen = text.length;
		var beg = 0;
		var end = data.length - 1;
		var i;
		var mi;
		var mis;

		while (beg < end) {
			mi = (beg + end) >> 1;
			i = data.lastIndexOf('\n', mi) + 1;

			mis = data.substr(i, tlen);
			if (text < mis) end = i - 1;
				else if (text > mis) beg = data.indexOf('\n', mi + 1) + 1;
					else return data.substring(i, data.indexOf('\n', mi + 1));
		}
		return null;
	},

	//

	//	Note: These are mostly flat text files; loaded as one continous string to reduce memory use
	loadDictionary: function() {
		this.wordDict = this.fileRead(ppkkoreanDict.datURI, ppkChineseDict.datCharset);
	},

  
  	shitSearch: function(book, word)
	{
		var params = {};
		params.korean = word;
		
		fi = book.indexOf( "\n" + word + ";");
	    if( fi == -1 )
	    {
			params.chinese = -1;
			return params;
	    }
		
		var lineStart = fi + 1;
		var lineEnd = book.indexOf("\r", fi+1);
		var line = book.substr(lineStart, lineEnd-lineStart);
		var entries = line.split(";");
		params.chinese = entries[1];
		
	    return params;
	},
	
	initial:[0x1100,0x1101,0x1102,0x1103,0x1104,0x1105,0x1106,0x1107,0x1108,0x1109,
			 0x110a,0x110b,0x110c,0x110d,0x110e,0x110f,0x1110,0x1111,0x1112],
	median:[0x1161,0x1162,0x1163,0x1164,0x1165,0x1166,0x1167,0x1168,0x1169,0x116a,0x116b,
			0x116c,0x116d,0x116e,0x116f,0x1170,0x1171,0x1172,0x1173,0x1174,0x1175],
	finale:[0, 0x11a8,0x11a9,0x11aA,0x11aB,0x11aC,0x11aD,0x11aE,0x11aF,0x11b0,0x11b1,0x11b2,
			0x11b3,0x11b4,0x11b5,0x11b6,0x11b7,0x11b8,0x11b9,0x11bA,0x11bB,0x11bC,0x11bD,
			0x11bE,0x11bF,0x11c0,0x11c1,0x11c2],
			
	initialR:["g","kk","n","d","tt","r","m","b","pp","s","ss","","j","jj","ch","k","t","p","h"],
	medianR:["a","ae","ya","yae","eo","e","yeo","ye","o","wa","wae","oe","yo","u","wo","we","wi","yu","eu","ui","i"],
	finaleR:[0,"k","kk","ks","n","nj","nh","t","l","lg","lm","lb","ls","lt","lp","lh","m","p","ps","s","ss","ng","j","ch","k","t","p","h"],
	
	inLanguageRange: function(u)
	{
		if( ((u < 0xAC00) || (u > 0xD7A3)) &&
			((u < 0x1100) || (u > 0x11FF)) &&
			((u < 0x3131) || (u > 0x318E)) &&
			((u < 0xFFA1) || (u > 0xFFDC)) )
			return false
		else
			return true;
	},
	
	dissectKoreanGlyph: function(glyph)
	{
		var codepoint = glyph[0].charCodeAt();
		
		if(this.inLanguageRange(codepoint) == false)
			return null;
			
		var params = {};
		params.whole = glyph;

		var tail = (codepoint - 44032) % 28;
		if(tail == 0)
			params.jFinal = params.rFinal = "";
		else
		{
			params.jFinal = String.fromCharCode(this.finale[tail]);
			params.rFinal = this.finaleR[tail];
		}
		
		var vowel = parseInt((1 + (codepoint - 44032 - tail) % 588) / 28);
		params.jMiddle = String.fromCharCode(this.median[vowel]);
		params.rMiddle = this.medianR[vowel];
		
		var lead = ((codepoint - 44032) / 588 ) | 0;
		params.jInitial = String.fromCharCode(this.initial[lead]);
		params.rInitial = this.initialR[lead];
		
		return params;
	},
	
	wordSearch: function(word, doNames, max)
   	{
   	   	var entry = { };
		entry.data = [];
   		var maxlen = 0;

   		//only process korean characters, stop at spaces etc
		for(ii = 0; ii < word.length; ii++)
		{
			var codepoint = word.charCodeAt(ii+1);
			if( (ii+1 > word.length - 1) || this.inLanguageRange(codepoint) == false )
			{
				maxlen = ii+1;
				break;
			}
		}
		
		var korean = "";
		var pron = "";
		var hanja = this.shitSearch(this.wordDict, word.substring(0,maxlen));
		
   		for(ii = 0; ii < maxlen; ii++)
   		{
   			var curr = this.dissectKoreanGlyph(word[ii]);
   			if(curr == null)
   				break;
   			korean += curr.whole;
   			if(ii == 0)
   				pron += curr.rInitial;
   				
	  		if(ii+1 >= maxlen)
				pron += curr.rMiddle + curr.rFinal;
	  		else //try to correct pronunciation based on next glyph per revised romanization
	  		{
	  			var next = this.dissectKoreanGlyph(word[ii+1]);
	  			if(next == null)
   					break;
   				pron += curr.rMiddle;
   				pron += this.getRevisedRomanization(curr, next);
	  		}
   		}
		
   		var theEntry = hanja.korean + " [" + pron + "] / " + (hanja.chinese == -1 ? "" : hanja.chinese) + " /"; 
   		entry.data.push([theEntry, null]);
   		entry.matchLen = maxlen;
    	return entry;
  	},
	
  	//returns revised romanization of current glyph final + next glyph initial
	getRevisedRomanization: function(currGlyph, nextGlyph)
	{
		if(currGlyph.jFinal == "")
			return nextGlyph.rInitial;
		switch(currGlyph.jFinal[0].charCodeAt())
		{
			case 0x11a8: //ᆨ
				switch(nextGlyph.jInitial[0].charCodeAt())
				{
					case 0x110b: //ᄋ
						return "g";
					break;
					case 0x1100: //ᄀ
						return "kg";
					break;
					case 0x1102: //ᄂ
						return "ngn";
					break;
					case 0x1103: //ᄃ
						return "kd";
					break;
					case 0x1105: //ᄅ
						return "ngn";
					break;
					case 0x1106: //ᄆ
						return "ngm";
					break;
					case 0x1107: //ᄇ
						return "kb";
					break;
					case 0x1109: //ᄉ
						return "ks";
					break;
					case 0x110c: //ᄌ
						return "kj";
					break;
					case 0x110e: //ᄎ
						return "kch";
					break;
					case 0x110f: //ᄏ
						return "k-k";
					break;
					case 0x1110: //ᄐ
						return "kt";
					break;
					case 0x1111: //ᄑ
						return "kp";
					break;
					case 0x1112: //ᄒ
						return "kh";
					break;
				}
			break;
			case 0x11aB: //ᆫ
				switch(nextGlyph.jInitial[0].charCodeAt())
				{
					case 0x110b: //ᄋ
						return "n";
					break;
					case 0x1100: //ᄀ
						return "n-g";
					break;
					case 0x1102: //ᄂ
						return "nn";
					break;
					case 0x1103: //ᄃ
						return "nd";
					break;
					case 0x1105: //ᄅ
						return "ll";
					break;
					case 0x1106: //ᄆ
						return "nm";
					break;
					case 0x1107: //ᄇ
						return "nb";
					break;
					case 0x1109: //ᄉ
						return "ns";
					break;
					case 0x110c: //ᄌ
						return "nj";
					break;
					case 0x110e: //ᄎ
						return "nch";
					break;
					case 0x110f: //ᄏ
						return "nk";
					break;
					case 0x1110: //ᄐ
						return "nt";
					break;
					case 0x1111: //ᄑ
						return "np";
					break;
					case 0x1112: //ᄒ
						return "nh";
					break;
				}
			break;
			case 0x11aE: //ᆮ
				switch(nextGlyph.jInitial[0].charCodeAt())
				{
					case 0x110b: //ᄋ
					return "d";
					break;
					case 0x1100: //ᄀ
					return "tg";
					break;
					case 0x1102: //ᄂ
					return "nn";
					break;
					case 0x1103: //ᄃ
					return "td";
					break;
					case 0x1105: //ᄅ
					return "nn";
					break;
					case 0x1106: //ᄆ
					return "nm";
					break;
					case 0x1107: //ᄇ
					return "tb";
					break;
					case 0x1109: //ᄉ
					return "ts";
					break;
					case 0x110c: //ᄌ
					return "tj";
					break;
					case 0x110e: //ᄎ
					return "tch";
					break;
					case 0x110f: //ᄏ
					return "tk";
					break;
					case 0x1110: //ᄐ
					return "t";
					break;
					case 0x1111: //ᄑ
					return "tp";
					break;
					case 0x1112: //ᄒ
					return "th";
					break;
				}
			break;
			case 0x11aF: //ᆯ
				switch(nextGlyph.jInitial[0].charCodeAt())
				{
					case 0x110b: //ᄋ
					return "r";
					break;
					case 0x1100: //ᄀ
					return "lg";
					break;
					case 0x1102: //ᄂ
					return "ll";
					break;
					case 0x1103: //ᄃ
					return "ld";
					break;
					case 0x1105: //ᄅ
					return "ll";
					break;
					case 0x1106: //ᄆ
					return "lm";
					break;
					case 0x1107: //ᄇ
					return "lb";
					break;
					case 0x1109: //ᄉ
					return "ls";
					break;
					case 0x110c: //ᄌ
					return "lj";
					break;
					case 0x110e: //ᄎ
					return "lch";
					break;
					case 0x110f: //ᄏ
					return "lk";
					break;
					case 0x1110: //ᄐ
					return "lt";
					break;
					case 0x1111: //ᄑ
					return "lp";
					break;
					case 0x1112: //ᄒ
					return "lh";
					break;
				}
			break;
			case 0x11b7: //ᆷ
				switch(nextGlyph.jInitial[0].charCodeAt())
				{
					case 0x110b: //ᄋ
					return "m";
					break;
					case 0x1100: //ᄀ
					return "mg";
					break;
					case 0x1102: //ᄂ
					return "mn";
					break;
					case 0x1103: //ᄃ
					return "md";
					break;
					case 0x1105: //ᄅ
					return "mn";
					break;
					case 0x1106: //ᄆ
					return "mm";
					break;
					case 0x1107: //ᄇ
					return "mb";
					break;
					case 0x1109: //ᄉ
					return "ms";
					break;
					case 0x110c: //ᄌ
					return "mj";
					break;
					case 0x110e: //ᄎ
					return "mch";
					break;
					case 0x110f: //ᄏ
					return "mk";
					break;
					case 0x1110: //ᄐ
					return "mt";
					break;
					case 0x1111: //ᄑ
					return "mp";
					break;
					case 0x1112: //ᄒ
					return "mh";
					break;
				}
			break;
			case 0x11b8: //ᆸ
				switch(nextGlyph.jInitial[0].charCodeAt())
				{
					case 0x110b: //ᄋ
					return "b";
					break;
					case 0x1100: //ᄀ
					return "pg";
					break;
					case 0x1102: //ᄂ
					return "mn";
					break;
					case 0x1103: //ᄃ
					return "pd";
					break;
					case 0x1105: //ᄅ
					return "mn";
					break;
					case 0x1106: //ᄆ
					return "mm";
					break;
					case 0x1107: //ᄇ
					return "pb";
					break;
					case 0x1109: //ᄉ
					return "ps";
					break;
					case 0x110c: //ᄌ
					return "pj";
					break;
					case 0x110e: //ᄎ
					return "pch";
					break;
					case 0x110f: //ᄏ
					return "pk";
					break;
					case 0x1110: //ᄐ
					return "pt";
					break;
					case 0x1111: //ᄑ
					return "p-p";
					break;
					case 0x1112: //ᄒ
					return "ph";
					break;
				}
			break;
			case 0x11bC: //ᆼ
				switch(nextGlyph.jInitial[0].charCodeAt())
				{
					case 0x110b: //ᄋ
					return "ng-";
					break;
					case 0x1100: //ᄀ
					return "ngg";
					break;
					case 0x1102: //ᄂ
					return "ngn";
					break;
					case 0x1103: //ᄃ
					return "ngd";
					break;
					case 0x1105: //ᄅ
					return "ngn";
					break;
					case 0x1106: //ᄆ
					return "ngm";
					break;
					case 0x1107: //ᄇ
					return "ngb";
					break;
					case 0x1109: //ᄉ
					return "ngs";
					break;
					case 0x110c: //ᄌ
					return "ngj";
					break;
					case 0x110e: //ᄎ
					return "ngch";
					break;
					case 0x110f: //ᄏ
					return "ngk";
					break;
					case 0x1110: //ᄐ
					return "ngt";
					break;
					case 0x1111: //ᄑ
					return "ngp";
					break;
					case 0x1112: //ᄒ
					return "ngh";
					break;
				}
			break;
			default:
				return currGlyph.rFinal + nextGlyph.rInitial;
			break;
		}
	},
	
	translate: function(text) {
		var e, o;
		var skip;

		o = {};
		o.data = [];
		o.textLen = text.length;

		while (text.length > 0) {
			e = this.wordSearch(text, false, 1);
			if (e != null) {
				if (o.data.length >= this.config.wmax) {
					o.more = 1;
					break;
				}
//				o.data = o.data.concat(e.data);
				o.data.push(e.data[0]);
				skip = e.matchLen;
			}
			else {
				skip = 1;
			}
			text = text.substr(skip, text.length - skip);
		}

		if (o.data.length == 0) {
			return null;
		}

		o.textLen -= text.length;
		return o;
	},

	makeHtml: function(entry) {
		var e;
		var b;
		var c, s, t;
		var i, j, n;

		if (entry == null) return '';

		b = [];

		if (entry.kanji) {
			var yomi;
			var box;
			var bn;
			var k;
			var nums;

			yomi = entry.onkun.replace(/\.([^\u3001]+)/g, '<span class="k-yomi-hi">$1</span>');
			if (entry.nanori.length) {
				yomi += '<br/><span class="k-yomi-ti">\u540D\u4E57\u308A</span> ' + entry.nanori;
			}
			if (entry.bushumei.length) {
				yomi += '<br/><span class="k-yomi-ti">\u90E8\u9996\u540D</span> ' + entry.bushumei;
			}

			bn = entry.misc['B'] - 1;
			k = entry.misc['G'];
			switch (k) {
			case 8:
				k = 'general<br/>use';
				break;
			case 9:
				k = 'name<br/>use';
				break;
			default:
				k = isNaN(k) ? '-' : ('grade<br/>' + k);
				break;
			}
			box = '<table class="k-abox-tb"><tr>' +
				'<td class="k-abox-r">radical<br/>' + this.radData[bn].charAt(0) + ' ' + (bn + 1) + '</td>' +
				'<td class="k-abox-g">' + k + '</td>' +
				'</tr><tr>' +
				'<td class="k-abox-f">freq<br/>' + (entry.misc['F'] ? entry.misc['F'] : '-') + '</td>' +
				'<td class="k-abox-s">strokes<br/>' + entry.misc['S'] + '</td>' +
				'</tr></table>';
			if (this.config.kdisp['COMP'] == 1) {
				k = this.radData[bn].split('\t');
				box += '<table class="k-bbox-tb">' +
						'<tr><td class="k-bbox-1a">' + k[0] + '</td>' +
						'<td class="k-bbox-1b">' + k[2] + '</td>' +
						'<td class="k-bbox-1b">' + k[3] + '</td></tr>';
				j = 1;
				for (i = 0; i < this.radData.length; ++i) {
					s = this.radData[i];
					if ((bn != i) && (s.indexOf(entry.kanji) != -1)) {
						k = s.split('\t');
						c = ' class="k-bbox-' + (j ^= 1);
						box += '<tr><td' + c + 'a">' + k[0] + '</td>' +
								'<td' + c + 'b">' + k[2] + '</td>' +
								'<td' + c + 'b">' + k[3] + '</td></tr>';
					}
				}
				box += '</table>';
			}

			nums = '';
			j = 0;

			for (i = 0; i < this.numList.length; i += 2) {
				c = this.numList[i];
				if (this.config.kdisp[c] == 1) {
					s = entry.misc[c];
					c = ' class="k-mix-td' + (j ^= 1) + '"';
					nums += '<tr><td' + c + '>' + this.numList[i + 1] + '</td><td' + c + '>' + (s ? s : '-') + '</td></tr>';
				}
			}
			if (nums.length) nums = '<table class="k-mix-tb">' + nums + '</table>';

			b.push('<table class="k-main-tb"><tr><td valign="top">');
			b.push(box);
			b.push('<span class="k-kanji">' + entry.kanji + '</span><br/>');
			b.push('<div class="k-eigo">' + entry.eigo + '</div>');
			b.push('<div class="k-yomi">' + yomi + '</div>');
			b.push('</td></tr><tr><td>' + nums + '</td></tr></table>');
			return b.join('');
		}

		s = t = '';

		if (entry.names) {
			c = [];

			b.push('<div class="w-title">Names Dictionary</div><table class="w-na-tb"><tr><td>');
			for (i = 0; i < entry.data.length; ++i) {
				e = entry.data[i][0].match(/^(.+?)\s+(?:\[(.*?)\])?\s*\/(.+)\//);
				if (!e) continue;

				if (s != e[3]) {
					c.push(t);
					t = '';
				}

				if (e[2]) c.push('<span class="w-kanji">' + e[1] + '</span>&#32;<span class="w-kana">' + e[2] + '</span><br/> ');
					else c.push('<span class="w-kana">' + e[1] + '</span><br/> ');

				s = e[3];
				t = '<span class="w-def">' + s.replace(/\//g, '; ') + '</span><br/>';
			}
			c.push(t);
			if (c.length > 4) {
				n = (c.length >> 1) + 1;
				b.push(c.slice(0, n + 1).join(''));

				t = c[n];
				c = c.slice(n, c.length);
				for (i = 0; i < c.length; ++i) {
					if (c[i].indexOf('w-def') != -1) {
						if (t != c[i]) b.push(c[i]);
						if (i == 0) c.shift();
						break;
					}
				}

				b.push('</td><td>');
				b.push(c.join(''));
			}
			else {
				b.push(c.join(''));
			}
			if (entry.more) b.push('...<br/>');
			b.push('</td></tr></table>');
		}
		else {
			if (entry.title) {
				b.push('<div class="w-title">' + entry.title + '</div>');
			}

			var pK = '';
			var k;

			for (i = 0; i < entry.data.length; ++i) {
				e = entry.data[i][0].match(/^(.+?)\s+(?:\[(.*?)\])?\s*\/(.+)\//);
				if (!e) continue;

				/*
					e[1] = kanji/kana
					e[2] = kana
					e[3] = definition
				*/

				if (s != e[3]) {
					b.push(t);
					pK = k = '';
				}
				else {
					k = t.length ? '<br/>' : '';
				}

				if (e[2]) {
					if (pK == e[1]) k = '\u3001 <span class="w-kana">' + e[2] + '</span>';
						else k += '<span class="w-kanji">' + e[1] + '</span> &#32; <span class="w-kana">' + e[2] + '</span>';
					pK = e[1];
				}
				else {
					k += '<span class="w-kana">' + e[1] + '</span>';
					pK = '';
				}
				b.push(k);

				if (entry.data[i][1]) b.push(' <span class="w-conj">(' + entry.data[i][1] + ')</span>');

				s = e[3];
				t = s.replace(/\//g, '; ');
				if (!this.config.wpos) t = t.replace(/^\([^)]+\)\s*/, '');
				if (!this.config.wpop) t = t.replace('; (P)', '');
				t = '<br/><span class="w-def">' + t + '</span><br/>';
			}
			b.push(t);
			if (entry.more) b.push('...<br/>');
		}

		return b.join('');
	},


	makeHtmlForRuby: function(entry) {
		var e;
		var b;
		var c, s, t;
		var i, j, n;

		if (entry == null) return '';

		b = [];

		s = t = '';

		if (entry.title) {
			b.push('<div class="w-title">' + entry.title + '</div>');
		}

		for (i = 0; i < entry.data.length; ++i) {
			e = entry.data[i][0].match(/^(.+?)\s+(?:\[(.*?)\])?\s*\/(.+)\//);
			if (!e) continue;

			s = e[3];
			t = s.replace(/\//g, '; ');
			if (!this.config.wpos) t = t.replace(/^\([^)]+\)\s*/, '');
			if (!this.config.wpop) t = t.replace('; (P)', '');
			t = '<span class="w-def">' + t + '</span><br/>\n';
		}
		b.push(t);

		return b.join('');
	},

	makeText: function(entry, max) {
		var e;
		var b;
		var i, j;
		var t;

		if (entry == null) return '';

		b = [];

		if (entry.kanji) {
			b.push(entry.kanji + '\n');
			b.push((entry.eigo.length ? entry.eigo : '-') + '\n');

			b.push(entry.onkun.replace(/\.([^\u3001]+)/g, '\uFF08$1\uFF09') + '\n');
			if (entry.nanori.length) {
				b.push('\u540D\u4E57\u308A\t' + entry.nanori + '\n');
			}
			if (entry.bushumei.length) {
				b.push('\u90E8\u9996\u540D\t' + entry.bushumei + '\n');
			}

			for (i = 0; i < this.numList.length; i += 2) {
				e = this.numList[i];
				if (this.config.kdisp[e] == 1) {
					j = entry.misc[e];
					b.push(this.numList[i + 1].replace('&amp;', '&') + '\t' + (j ? j : '-') + '\n');
				}
			}
		}
		else {
			if (max > entry.data.length) max = entry.data.length;
			for (i = 0; i < max; ++i) {
				e = entry.data[i][0].match(/^(.+?)\s+(?:\[(.*?)\])?\s*\/(.+)\//);
				if (!e) continue;

				if (e[2]) {
					b.push(e[1] + '\t' + e[2]);
				}
				else {
					b.push(e[1]);
				}

				t = e[3].replace(/\//g, '; ');
				if (!this.config.wpos) t = t.replace(/^\([^)]+\)\s*/, '');
				if (!this.config.wpop) t = t.replace('; (P)', '');
				b.push('\t' + t + '\n');
			}
		}
		return b.join('');
	}
};

