/*

	Perapera-kun
	Justin Kovalchuk
	http://perapera.wordpress.com/
	
	---
	
	Based on Rikaichan by Jonathan Zarate
	Copyright (C) 2005-2009 
	http://www.polarcloud.com/
	
	---

	Originally based on RikaiXUL 0.4 by Todd Rudick
	http://www.rikai.com/
	http://rikaixul.mozdev.org/

	---

	This program is free software; you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation; either version 2 of the License, or
	(at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

	---

	Please do not change or remove any of the copyrights or links to web pages
	when modifying any of the files. - Jon

*/
var Languages = {"Japanese" : 0, "Chinese" : 1, "Korean": 2};

var peraMain = {
	currentLanguage: null,
	haveNames: false,
	canDoNames: false,
	dictCount: 0,
	altView: 0,
	enabled: 0,
	enabledLangs: {jap:false, chn:false, kor:false},
	
	init: function() {
		window.addEventListener('load', this.onLoad, false);
	},

    getCurrentBrowser: function() {
		if (this.isTB) {
			var b = document.getElementById('messagepane');
			if (b) return b;
			return document.getElementById('content-frame');	// compose
		}
		else {
			return gBrowser.mCurrentBrowser;
		}
    },

	hiddenDOMWindow: function() {
		return Components.classes["@mozilla.org/appshell/appShellService;1"]
			.getService(Components.interfaces.nsIAppShellService)
			.hiddenDOMWindow;
	},

	tbObs: {
		observe: function(subject, topic, data) {
			if (topic == 'mail:composeOnSend') {
				var e = window.content.document.getElementById('perakun-css');
				if (e) e.parentNode.removeChild(e);
				e = window.content.document.getElementById('perakun-window');
				if (e) e.parentNode.removeChild(e);
			}
		},
		register: function() {
			Components.classes['@mozilla.org/observer-service;1']
				.getService(Components.interfaces.nsIObserverService)
				.addObserver(peraMain.tbObs, 'mail:composeOnSend', false);
		},
		unregister: function() {
			Components.classes['@mozilla.org/observer-service;1']
				.getService(Components.interfaces.nsIObserverService)
				.removeObserver(peraMain.tbObs, 'mail:composeOnSend');
		}
	},

	peraObs: {
		observe: function(subject, topic, data) {
			if (topic == 'perakun') {
				if ((peraMain.cfg.enmode == 2) && ((data == 'enable') || (data == 'disable'))) {
					if (peraMain.enabled != (data == 'enable')) {
						if (peraMain.enabled) peraMain.inlineDisable(gBrowser.mCurrentBrowser, 0);
							else peraMain.enabled = 1;
						peraMain.onTabSelect();
					}
				}
			}
		},
		register: function() {
			Components.classes["@mozilla.org/observer-service;1"]
				.getService(Components.interfaces.nsIObserverService)
				.addObserver(peraMain.peraObs, 'perakun', false);
		},
		unregister: function() {
			Components.classes['@mozilla.org/observer-service;1']
				.getService(Components.interfaces.nsIObserverService)
				.removeObserver(peraMain.peraObs, 'perakun');
		},
		notifyState: function(state) {
			Components.classes['@mozilla.org/observer-service;1']
				.getService(Components.interfaces.nsIObserverService)
				.notifyObservers(null, 'perakun', state);
		}
	},

    onLoad: function() { peraMain._onLoad(); },
	_onLoad: function() {
		try {
			window.addEventListener('unload', this.onUnload, false);

			this.haveNames = this.canDoNames = (typeof(rcxNamesDict) != 'undefined');

			var docID = document.documentElement.id;
			this.isTB = ((docID == "messengerWindow") || (docID == "msgcomposeWindow"));

			var mks;
			if (this.isTB) {
				mks = document.getElementById('mailKeys') || document.getElementById('editorKeys');
			}
			else {
				mks = document.getElementById('mainKeyset') || document.getElementById('navKeys');
				gBrowser.mTabContainer.addEventListener('select', this.onTabSelect, false);
			}

			var pb = this.getPrefBranch();
			var names = ['toggle', 'lbar'];

			for (var i = 1; i >= 0; --i) {
				var na = names[i];
				var v = pb.getCharPref(na + '.key');
				if ((v.length > 0) && (v != '(disabled)')) {
					var key = document.createElementNS(
							'http://www.mozilla.org/keymaster/gatekeeper/there.is.only.xul', 'key');
					key.setAttribute('id', 'perakun-key-' + na);
					if (v.length > 1) key.setAttribute('keycode', 'VK_' + v.replace(' ', '_').toUpperCase());	// "Page Up" -> "VK_PAGE_UP"
						else key.setAttribute('key', v);
					key.setAttribute('modifiers', pb.getCharPref(na + '.mod'));
					key.setAttribute('command', 'perakun-' + na + '-cmd');
					mks.appendChild(key);
				}
			}

			this.loadPrefs();
			this.prefObs.register();
			if (this.isTB) {
				this.tbObs.register();
			}
			else {
				this.peraObs.register();

				if (peraMain.cfg.enmode == 2) {
					if (this.hiddenDOMWindow().perakun_active == 1) {
						this.enabled = 1;
						this.onTabSelect();
					}
				}
			}

			if (peraMain.cfg.checkversion)
			{
				var timer = Components.classes["@mozilla.org/timer;1"]
       							.createInstance(Components.interfaces.nsITimer);
       			timer.initWithCallback(function(){peraMain.checkVersion();},2000,timer.TYPE_ONE_SHOT);
			}
			
			//this is used in prefs dialog to set images
			var pb = Components
				.classes['@mozilla.org/preferences-service;1']
				.getService(Components.interfaces.nsIPrefService)
				.getBranch('perakun.');
			
			//need to use this to get access in prefs dialog
			pb.setBoolPref('chinese_installed', typeof(ppkChineseDict) == 'undefined' ? false : true);
			pb.setBoolPref('japanese_installed', typeof(rcxWordDict) == 'undefined' ? false : true);
			pb.setBoolPref('korean_installed', typeof(ppkkoreanDict) == 'undefined' ? false : true);
			
			var enableCount = 0;
			
			
			var isHidden = pb.getBoolPref('chinese_enabled') == false || pb.getBoolPref('chinese_installed') == false;
			document.getElementById('perakun-statuspopup-chinese').setAttribute('hidden', isHidden);
			document.getElementById('perakun-tbarpopup-chinese').setAttribute('hidden', isHidden);
			this.enabledLangs.chn = !isHidden;
			
			isHidden = pb.getBoolPref('japanese_enabled') == false || pb.getBoolPref('japanese_installed') == false;
			document.getElementById('perakun-statuspopup-japanese').setAttribute('hidden', isHidden);
			document.getElementById('perakun-tbarpopup-japanese').setAttribute('hidden', isHidden);
			this.enabledLangs.jap = !isHidden;
			

			isHidden = pb.getBoolPref('korean_enabled') == false || pb.getBoolPref('korean_installed') == false;
			document.getElementById('perakun-statuspopup-korean').setAttribute('hidden', isHidden);
			document.getElementById('perakun-tbarpopup-korean').setAttribute('hidden', isHidden);
			this.enabledLangs.kor = !isHidden;
		}
		catch (ex) {
			alert('Exception in onLoad: ' + ex);
		}
	},

	onUnload: function() { peraMain._onUnload(); },
	_onUnload: function() {
		this.prefObs.unregister();
        if (this.isTB) {
			this.tbObs.unregister();
		}
		else {
			gBrowser.mTabContainer.removeEventListener('select', this.onTabSelect, false);
			this.peraObs.unregister();
		}

		if (this.dict) peraMain.dict.unlock();
	},

	//

	getPrefBranch: function() {
	    return Components.classes['@mozilla.org/preferences-service;1']
				.getService(Components.interfaces.nsIPrefService)
				.getBranch('perakun.');
	},

	prefObs: {
		observe: function(aSubject, aTopic, aPrefName) {
            peraMain.loadPrefs();
		},
		register: function() {
			Components.classes['@mozilla.org/preferences-service;1']
				.getService(Components.interfaces.nsIPrefBranch)
				.QueryInterface(Components.interfaces.nsIPrefBranchInternal)
				.addObserver('perakun.', peraMain.prefObs, false);
		},
		unregister: function() {
			Components.classes['@mozilla.org/preferences-service;1']
					.getService(Components.interfaces.nsIPrefBranch)
					.QueryInterface(Components.interfaces.nsIPrefBranchInternal)
					.removeObserver('perakun.', peraMain.prefObs);
		}
	},

	loadPrefs: function() {
		try {
		    var pb = this.getPrefBranch();
			var xm = ['cm', 'tm'];
			var i;
			var a, b, c;

			this.cfg = {};
			for (i = 0; i < peraCfgList.length; ++i) {
				b = peraCfgList[i];
				switch (b[0]) {
				case 0:
					this.cfg[b[1]] = pb.getIntPref(b[1]);
					break;
				case 1:
					this.cfg[b[1]] = pb.getCharPref(b[1]);
					break;
				case 2:
					this.cfg[b[1]] = pb.getBoolPref(b[1]);
					break;
				}
			}

			this.dictCount = 3;
			this.canDoNames = this.haveNames;
			if (!this.haveNames) this.cfg.dictorder = 0;
			switch (this.cfg.dictorder) {
			case 0:
				this.canDoNames = false;
				this.dictCount = 2;
			case 1:
				this.kanjiN = 1;
				this.namesN = 2;
				break;
			case 2:
				this.kanjiN = 2;
				this.namesN = 1;
				break;
			}

			for (i = 1; i >= 0; --i) {
				c = xm[i];
				try {
					a = !this.cfg[c + 'toggle'];
					b = !this.cfg[c + 'lbar'];
					document.getElementById('perakun-toggle-' + c).hidden = a;
					document.getElementById('perakun-lbar-' + c).hidden = b;
					document.getElementById('perakun-separator-' + xm[i]).hidden = a || b;
				}
				catch (ex) {
					//	alert('unable to set menu: c=' + c + ' ex=' + ex)
				}
			}

			switch (this.cfg.ssep) {
			case 'Tab':
				this.cfg.ssep = '\t';
				break;
			case 'Comma':
				this.cfg.ssep = ',';
				break;
			case 'Space':
				this.cfg.ssep = ' ';
				break;
			}

			this.cfg.css = (this.cfg.css.indexOf('/') == -1) ? ('chrome://perakun/skin/popup-' + this.cfg.css + '.css') : this.cfg.css;
			if (!this.isTB) {
				for (i = 0; i < gBrowser.browsers.length; ++i) {
					c = gBrowser.browsers[i].contentDocument.getElementById('perakun-css');
					if (c) c.setAttribute('href', this.cfg.css);
				}
			}

			c = { };
			c.kdisp = [];
			a = pb.getCharPref('kindex').split(',');
			for (i = 0; i < a.length; ++i) {
				c.kdisp[a[i]] = 1;
			}
			c.wmax = this.cfg.wmax;
			c.wpop = this.cfg.wpop;
			c.wpos = this.cfg.wpos;
			c.namax = this.cfg.namax;
			this.dconfig = c;
			if (this.dict) this.dict.setConfig(c);

			if (this.isTB) this.cfg.enmode = 0;

			b = document.getElementById('perakun-status');
			if (b) b.hidden = (this.cfg.sticon == 0);
		}
		catch (ex) {
			alert('Exception in LoadPrefs: ' + ex);
		}
	},

	loadDictionary: function() {
		if(this.currentLangauge = null)
		{	
			alert("Current dictionary is not set.");
			return;
		}
 		var pb = Components
			.classes['@mozilla.org/preferences-service;1']
			.getService(Components.interfaces.nsIPrefService)
			.getBranch('perakun.');

		switch(this.currentLanguage)
		{
			case Languages.Chinese:
				if (!this.dict) {
					if (pb.getBoolPref('chinese_installed') == false) {
						this.showDownload(Languages.Chinese);
						return false;
					}
					try {
						this.dict = new chnDict();
						this.dict.setConfig(this.dconfig);
					}
					catch (ex) {
						alert('Error loading dictionary: ' + ex);
						return false;
					}
		
					this.status('Chinese Loaded.');
					return true;
				}
			break;
			case Languages.Korean:
				if (!this.dict) {
					if (pb.getBoolPref('korean_installed') == false) {
						this.showDownload(Languages.Korean);
						return false;
					}
					try {
						this.dict = new korDict();
						this.dict.setConfig(this.dconfig);
					}
					catch (ex) {
						alert('Error loading dictionary: ' + ex);
						return false;
					}
		
					this.status('Korean Loaded.');
					return true;
				}
			break;
			case Languages.Japanese:
				if (!this.dict) {
					if (pb.getBoolPref('japanese_installed') == false) {
						this.showDownload(Languages.Japanese);
						return false;
					}
					try {
						this.dict = new jpnDict(this.haveNames && !this.cfg.nadelay);
						this.dict.setConfig(this.dconfig);
					}
					catch (ex) {
						alert('Error loading dictionary: ' + ex);
						return false;
					}
		
					this.status('Japanese Loaded.');
					return true;
				}
			break;
		}
	},
	
	firstRun: function() {
		const url = 'http://perapera.wordpress.com/worth-a-cup-of-coffee/';
		var w = null;
		if (this.isTB) {
			Components.classes['@mozilla.org/messenger;1'].createInstance()
				.QueryInterface(Components.interfaces.nsIMessenger)
				.launchExternalURL(url);
		}
		else {
			w = window.open(url, 'peraperakun');
			if (w) w.focus();
		}
		Components.classes['@mozilla.org/embedcomp/prompt-service;1']
			.getService(Components.interfaces.nsIPromptService)
			.alert(w, 'Perapera-kun Message',  'If you dont have any dictionaries installed yet, please visit my webpage for information on downloading and installing.\n\n http://perapera.wordpress.com/');
	},
	
	showDownload: function(language) {
		var url;
		switch(language)
		{
			case Languages.Chinese:
				url = 'http://perapera.wordpress.com/chinese/';
			break;
			case Languages.Japanese:
				url = 'http://perapera.wordpress.com/perapera-kun/';
			break;
			case Languages.Korean:
				url = 'http://perapera.wordpress.com/korean/';
			break;
		}
		if (this.isTB) {
			Components.classes['@mozilla.org/messenger;1'].createInstance()
				.QueryInterface(Components.interfaces.nsIMessenger)
				.launchExternalURL(url);
		}
		else {
			var w = window.open(url, 'peraperakun');
			if (w) w.focus();
		}
	},

	checkVersion: function() {
		try {
			var v, p;

			try {
				// not in SeaMonkey?
				v = Components.classes['@mozilla.org/extensions/manager;1']
					.getService(Components.interfaces.nsIExtensionManager)
					.getItemForID('peraperakun@gmail.com').version;
			}
			catch (ex) {
				v = '?';
			}

			p = this.getPrefBranch();
			if ((!p.prefHasUserValue('version')) || (p.getCharPref('version') != v)) {
				p.setCharPref('version', v);
				this.firstRun();
			}
		}
		catch (ex) {
			//	alert('checkVersion: ' + ex);
		}
	},

	onTabSelect: function() { peraMain._onTabSelect(); },
	_onTabSelect: function() {
		var bro = this.getCurrentBrowser();
		var pb = this.getPrefBranch();
		
		if ((this.cfg.enmode > 0) && (this.enabled == 1) && (bro.perakun == null))
			this.inlineEnable(bro, 0); 
			
		var b = document.getElementById('perakun-toggle-button');
		if (b && bro.perakun != null)
		{
			switch(this.currentLanguage)
			{
				case Languages.Chinese:
					b.setAttribute('pera_lang', "chinese");
					if(pb.getBoolPref('safeflag') == true)
						b.setAttribute('flag', "safe");
					else
						b.setAttribute('flag', "default");
				break;
				case Languages.Japanese:
					b.setAttribute('pera_lang', "japanese");
				break;
				case Languages.Korean:
					b.setAttribute('pera_lang', "korean");
				break;
			}
		}

		var en = (bro.perakun != null);
		b = document.getElementById('perakun-toggle-cmd');
		if (b) b.setAttribute('checked', en);	
		// note: above doesn't work in TB 2.x
		if (this.isTB) {
			b = document.getElementById('perakun-toggle-cm');
			if (b) b.setAttribute('checked', en);
			b = document.getElementById('perakun-toggle-tm');
			if (b) b.setAttribute('checked', en);
			b = document.getElementById('perakun-toggle-sm');
			if (b) b.setAttribute('checked', en);
		}

		b = document.getElementById('perakun-status');
		if (b && bro.perakun != null) 
		{
			switch(this.currentLanguage)
			{
				case Languages.Chinese:
					b.setAttribute('pera_lang', "chinese");
					if(pb.getBoolPref('safeflag') == true)
						b.setAttribute('flag', "safe");
					else
						b.setAttribute('flag', "default")
				break;
				case Languages.Japanese:
					b.setAttribute('pera_lang', "japanese");
				break;
				case Languages.Korean:
					b.setAttribute('pera_lang', "korean");
				break;
			}
		}
	},

	showPopup: function(text, elem, x, y, looseWidth, lbPop) {
		const topdoc = content.document;

		if ((isNaN(x)) || (isNaN(y))) x = y = 0;

		this.lbPop = lbPop;

		var popup = topdoc.getElementById('perakun-window');
		if (!popup) {
			var css = topdoc.createElementNS('http://www.w3.org/1999/xhtml', 'link');
			css.setAttribute('rel', 'stylesheet');
			css.setAttribute('type', 'text/css');
			css.setAttribute('href', this.cfg.css);
			css.setAttribute('id', 'perakun-css');
			topdoc.getElementsByTagName('head')[0].appendChild(css);

			popup = topdoc.createElementNS('http://www.w3.org/1999/xhtml', 'div');
			popup.setAttribute('id', 'perakun-window');
			topdoc.documentElement.appendChild(popup);

			popup.addEventListener('dblclick',
				function (ev) {
					peraMain.hidePopup();
					ev.stopPropagation();
				}, true);

			if (this.cfg.resizedoc) {
				if ((topdoc.body.clientHeight < 1024) && (topdoc.body.style.minHeight == '')) {
					topdoc.body.style.minHeight = '1024px';
					topdoc.body.style.overflow = 'auto';
				}
			}
		}

		popup.style.width = 'auto';
		popup.style.height = 'auto';
		popup.style.maxWidth = (looseWidth ? '' : '600px');

		if (topdoc.contentType == 'text/plain') {
			var df = document.createDocumentFragment();
			df.appendChild(document.createElementNS('http://www.w3.org/1999/xhtml', 'span'));
			df.firstChild.innerHTML = text;

			while (popup.firstChild) {
				popup.removeChild(popup.firstChild);
			}
			popup.appendChild(df.firstChild);
		}
		else {
			popup.innerHTML = text;
		}

		if (elem) {
			popup.style.top = '-1000px';
			popup.style.left = '0px';
			popup.style.display = '';

			const bbo = this.getCurrentBrowser().boxObject;
			var pW = popup.offsetWidth;
			var pH = popup.offsetHeight;

			// guess!
			if (pW <= 0) pW = 200;
			if (pH <= 0) {
				pH = 0;
				var j = 0;
				while ((j = text.indexOf('<br/>', j)) != -1) {
					j += 5;
					pH += 22;
				}
				pH += 25;
			}

			if (this.altView == 1) {
				x = content.scrollX;
				y = content.scrollY;
			}
			else if (this.altView == 2) {
				x = (content.innerWidth - (pW + 20)) + content.scrollX;
				y = (content.innerHeight - (pH + 20)) + content.scrollY;
			}
			else if (elem instanceof Components.interfaces.nsIDOMHTMLOptionElement) {
				// these things are always on z-top, so go sideways

				x = 0;
				y = 0;

				var p = elem;
				while (p) {
					x += p.offsetLeft;
					y += p.offsetTop;
					p = p.offsetParent;
				}
				if (elem.offsetTop > elem.parentNode.clientHeight) y -= elem.offsetTop;

				if ((x + popup.offsetWidth) > content.innerWidth) {
					// too much to the right, go left
					x -= popup.offsetWidth + 5;
					if (x < 0) x = 0;
				}
				else {
					// use SELECT's width
					x += elem.parentNode.offsetWidth + 5;
				}

/*
				// in some cases (ex: google.co.jp), ebo doesn't add the width of the scroller (?), so use SELECT's width
				const epbo = elem.ownerDocument.getBoxObjectFor(elem.parentNode);

				const ebo = elem.ownerDocument.getBoxObjectFor(elem);
				x = ebo.screenX - bbo.screenX;
				y = ebo.screenY - bbo.screenY;

				if (x > (content.innerWidth - (x + epbo.width))) {
					x = (x - popup.offsetWidth - 5);
					if (x < 0) x = 0;
				}
				else {
					x += epbo.width + 5;
				}
*/
			}
			else {
				x -= bbo.screenX;
				y -= bbo.screenY;

				// go left if necessary
				if ((x + pW) > (content.innerWidth - 20)) {
					x = (content.innerWidth - pW) - 20;
					if (x < 0) x = 0;
				}

				// below the mouse
				var v = 25;

				// under the popup title
				if ((elem.title) && (elem.title != '')) v += 20;

				// go up if necessary
				if ((y + v + pH) > content.innerHeight) {
					var t = y - pH - 30;
					if (t >= 0) y = t;
				}
				else y += v;

				x += content.scrollX;
				y += content.scrollY;
			}
		}
		else {
			x += content.scrollX;
			y += content.scrollY;
		}

		popup.style.left = x + 'px';
		popup.style.top = y + 'px';
		popup.style.display = '';
	},

	hidePopup: function() {
		var popup = window.content.document.getElementById('perakun-window');
		if (popup) {
			popup.style.display = 'none';
			popup.innerHTML = '';
		}
		this.lbPop = 0;
		this.title = null;
	},

	isVisible: function() {
		var popup = window.content.document.getElementById('perakun-window');
		return (popup) && (popup.style.display != 'none');
	},

	clearHi: function() {
		var tdata = this.getCurrentBrowser().perakun;
		if ((!tdata) || (!tdata.prevSelView)) return;
		if (tdata.prevSelView.closed) {
			tdata.prevSelView = null;
			return;
		}

		var sel = tdata.prevSelView.getSelection();
		if ((sel.isCollapsed) || (tdata.selText == sel.toString())) {
			sel.removeAllRanges();
		}
		tdata.prevSelView = null;
		tdata.kanjiChar = null;
		tdata.selText = null;
	},

	//

	lastFound: null,

	savePrep: function(clip) {
		var me, mk;
		var text;
		var i;
		var f;
		var e;

		f = this.lastFound;
		if ((!f) || (f.length == 0)) return null;

		if (clip) {
			me = this.cfg.smaxce;
			mk = this.cfg.smaxck;
		}
		else {
			me = this.cfg.smaxfe;
			mk = this.cfg.smaxfk;
		}

		if (!this.fromLB) mk = 1;

		text = '';
		for (i = 0; i < f.length; ++i) {
			e = f[i];
			if (e.kanji) {
				if (mk-- <= 0) continue
				text += this.dict.makeText(e, 1);
			}
			else {
				if (me <= 0) continue;
				text += this.dict.makeText(e, me);
				me -= e.data.length;
			}
		}

		if (this.cfg.snlf == 1) text = text.replace(/\n/g, '\r\n');
			else if (this.cfg.snlf == 2) text = text.replace(/\n/g, '\r');
		if (this.cfg.ssep != '\t') return text.replace(/\t/g, this.cfg.ssep);

		return text;
	},

	copyToClip: function() {
		var text;

		if ((text = this.savePrep(1)) != null) {
			Components.classes['@mozilla.org/widget/clipboardhelper;1']
				.getService(Components.interfaces.nsIClipboardHelper)
				.copyString(text);
			this.showPopup('Copied to clipboard.');
		}
	},
	
	saveToKotobaBar: function() {
		var text;
		if ((text = this.savePrep(0)) == null) return;

		toggleSidebar('viewKotobaSidebar', true);
		var sidebarWindow = document.getElementById("sidebar").contentWindow;

		var entries = text.split('\r\n');
		for(ii = 0; ii < entries.length; ii++)
		{
			var entry = entries[ii].replace(/\n/g, '');
			entry = entry.replace(/\r/g, '');
			var temp =  entries[ii].split(this.cfg.ssep);
			if(temp.length == 2)
				sidebarWindow.kotobabar.addEntry(temp[0],temp[0],temp[1]);
			else if (temp.length == 3)
				sidebarWindow.kotobabar.addEntry(temp[0],temp[1],temp[2]);
		}
	},
	
	saveToFile: function() {
		var text;
		var i;
		var lf, fos, os;

		try {
			if ((text = this.savePrep(0)) == null) return;

			if (this.cfg.sfile.length == 0) {
				this.showPopup('Please set the filename in Preferences.');
				return;
			}

			lf = Components.classes['@mozilla.org/file/local;1']
					.createInstance(Components.interfaces.nsILocalFile);

			lf.initWithPath(this.cfg.sfile);

			fos = Components.classes['@mozilla.org/network/file-output-stream;1']
				.createInstance(Components.interfaces.nsIFileOutputStream);
			fos.init(lf, 0x02 | 0x08 | 0x10, 0644, 0);

			os = Components.classes['@mozilla.org/intl/converter-output-stream;1']
					.createInstance(Components.interfaces.nsIConverterOutputStream);
			os.init(fos, this.cfg.sfcs, 0, 0x3F);	// unknown -> '?'
			os.writeString(text);
			os.close();

			fos.close();

			this.showPopup('Saved.');
		}
		catch (ex) {
			this.showPopup('Error while saving: ' + ex);
		}
	},

	configPage: function() {
		window.openDialog('chrome://perakun/content/prefs.xul', '', 'chrome,centerscreen');
	},

	//

	keysDown: [],

	onKeyDown: function(ev) { peraMain._onKeyDown(ev) },
	_onKeyDown: function(ev) {
//		this.status("keyCode=" + ev.keyCode + ' charCode=' + ev.charCode + ' detail=' + ev.detail);

		if ((ev.altKey) || (ev.metaKey) || (ev.ctrlKey)) return;
		if ((ev.shiftKey) && (ev.keyCode != 16)) return;
		if (this.keysDown[ev.keyCode]) return;
		if (!this.isVisible()) return;
		if ((this.cfg.nopopkeys) && (ev.keyCode != 16)) return;

		var i;

		switch (ev.keyCode) {
		case 16:	// shift
		case 13:	// enter
			this.showMode = (this.showMode + 1) % this.dictCount;
			this.show(ev.currentTarget.perakun);
			break;
		case 27:	// esc
			this.hidePopup();
			break;
		case 65:	// a
			this.altView = (this.altView + 1) % 3;
			if (this.altView) this.status('Alternate View #' + this.altView);
				else this.status('Normal View');
			this.show(ev.currentTarget.perakun);
			break;
		case 67:	// c
			this.copyToClip();
			break;
		case 83:	// s
			this.saveToKotobaBar();
			break;
		case 66:	// b
			var ofs = ev.currentTarget.perakun.uofs;
			for (i = 50; i > 0; --i) {
				ev.currentTarget.perakun.uofs = --ofs;
				this.showMode = 0;
				if (this.show(ev.currentTarget.perakun) >= 0) {
					if (ofs >= ev.currentTarget.perakun.uofs) break;	// ! change later
				}
			}
			break;
		case 77:	// m
			ev.currentTarget.perakun.uofsNext = 1;
		case 78:	// n
			for (i = 50; i > 0; --i) {
				ev.currentTarget.perakun.uofs += ev.currentTarget.perakun.uofsNext;
				this.showMode = 0;
				if (this.show(ev.currentTarget.perakun) >= 0) break;
			}
			break;
		case 89:	// y
			this.altView = 0;
			ev.currentTarget.perakun.popY += 20;
			this.show(ev.currentTarget.perakun);
			break;
		default:
			return;
		}

		this.keysDown[ev.keyCode] = 1;

		// don't eat shift if in this mode
		if (!this.cfg.nopopkeys) {
			ev.preventDefault();
		}
	},

	onKeyUp: function(ev) {
		if (peraMain.keysDown[ev.keyCode]) peraMain.keysDown[ev.keyCode] = 0;
	},


	mouseButtons: 0,

	onMouseDown: function(ev) {
		peraMain.mouseButtons |= (1 << ev.button);
		if (peraMain.lbPop) {
			var e = ev.target;
			for (var i = 15; (i > 0) && (e != null); --i) {
				if (e.id == 'perakun-window') return;
				e = e.parentNode;
			}
		}
		peraMain.hidePopup();
	},

	onMouseUp: function(ev) {
		peraMain.mouseButtons &= ~(1 << ev.button);
	},

	unicodeInfo: function(c) {
		const hex = '0123456789ABCDEF';
		const u = c.charCodeAt(0);
		return c + ' U' + hex[(u >>> 12) & 15] + hex[(u >>> 8) & 15] + hex[(u >>> 4) & 15] + hex[u & 15];
	},

	kanjiN: 1,
	namesN: 2,

	inlineNames: {
		// text node
		'#text': true,

		// font style
		'FONT': true,
		'TT': true,
		'I' : true,
		'B' : true,
		'BIG' : true,
		'SMALL' : true,
		//deprecated
		'STRIKE': true,
		'S': true,
		'U': true,

		// phrase
		'EM': true,
		'STRONG': true,
		'DFN': true,
		'CODE': true,
		'SAMP': true,
		'KBD': true,
		'VAR': true,
		'CITE': true,
		'ABBR': true,
		'ACRONYM': true,

		// special, not included IMG, OBJECT, BR, SCRIPT, MAP, BDO
		'A': true,
		'Q': true,
		'SUB': true,
		'SUP': true,
		'SPAN': true,
		'WBR': true,

		// ruby
		'RUBY': true,
		'RBC': true,
		'RTC': true,
		'RB': true,
		'RT': true,
		'RP': true
	},

	isInline: function(node) {
		return this.inlineNames.hasOwnProperty(node.nodeName);
	},

	// XPath expression which evaluates to text nodes
	// tells perakun which text to translate
	// expression to get all text nodes that are not in (RP or RT) elements
	textNodeExpr: 'descendant-or-self::text()[not(parent::rp) and not(ancestor::rt)]',

	// XPath expression which evaluates to a boolean. If it evaluates to true
	// then perakun will not start looking for text in this text node
	// ignore text in RT elements
	startElementExpr: 'boolean(parent::rp or ancestor::rt)',

	// Gets text from a node
	// returns a string
	// node: a node
	// selEnd: the selection end object will be changed as a side effect
	// maxLength: the maximum length of returned string
	// xpathExpr: an XPath expression, which evaluates to text nodes, will be evaluated
	// relative to "node" argument
	getInlineText: function (node, selEndList, maxLength, xpathExpr) {
		var text = '';
		var endIndex;

		if (node.nodeName == '#text') {
			endIndex = Math.min(maxLength, node.data.length);
			selEndList.push({node: node, offset: endIndex});
			return node.data.substring(0, endIndex);
		}

		var result = xpathExpr.evaluate(node, XPathResult.ORDERED_NODE_ITERATOR_TYPE, null);

		while ((text.length < maxLength) && (node = result.iterateNext())) {
			endIndex = Math.min(node.data.length, maxLength - text.length);
			text += node.data.substring(0, endIndex);
			selEndList.push( {node: node, offset: endIndex} );
		}

		return text;
	},

	// given a node which must not be null,
	// returns either the next sibling or next sibling of the father or
	// next sibling of the fathers father and so on or null
	getNext: function(node) {
		var nextNode;

		if ((nextNode = node.nextSibling) != null)
			return nextNode
		if (((nextNode = node.parentNode) != null) && this.isInline(nextNode))
			return this.getNext(nextNode);

		return null;
	},

	getTextFromRange: function (rangeParent, offset, selEndList, maxLength) {
		var text = '';
		var endIndex;

		var xpathExpr = rangeParent.ownerDocument.createExpression(this.textNodeExpr, null);

		if (rangeParent.ownerDocument.evaluate(this.startElementExpr, rangeParent, null, XPathResult.BOOLEAN_TYPE, null).booleanValue)
			return '';

		if (rangeParent.nodeType != Node.TEXT_NODE)
			return '';

		endIndex = Math.min(rangeParent.data.length, offset + maxLength);
		text += rangeParent.data.substring(offset, endIndex);
		selEndList.push( {node: rangeParent, offset: endIndex} );

		var nextNode = rangeParent;
		while (((nextNode = this.getNext(nextNode)) != null) && (this.isInline(nextNode)) && (text.length < maxLength))
			text += this.getInlineText(nextNode, selEndList, maxLength - text.length, xpathExpr);

		return text;
	},

	show: function(tdata) {
		var rp = tdata.prevRangeNode;
		var ro = tdata.prevRangeOfs + tdata.uofs;
		var u;

		tdata.uofsNext = 1;

		if (!rp) {
			this.clearHi();
			this.hidePopup();
			return 0;
		}

		if ((ro < 0) || (ro >= rp.data.length)) {
			this.clearHi();
			this.hidePopup();
			return 0;
		}

		// if we have '   XYZ', where whitespace is compressed, X never seems to get selected
		while (((u = rp.data.charCodeAt(ro)) == 32) || (u == 9) || (u == 10)) {
			++ro;
			if (ro >= rp.data.length) {
				this.clearHi();
				this.hidePopup();
				return 0;
			}
		}

		if ( (isNaN(u)) || (this.dict.inLanguageRange(u) == false) )
		{
			this.clearHi();
			this.hidePopup();
			return -2;
		}
		
		//selection end data
		var selEndList = [];
		var text = this.getTextFromRange(rp, ro, selEndList, 13);
		rp = tdata.prevRangeNode;
		var e = null;
		var m = this.showMode;

		do {
			switch (this.showMode) {
			case 0:
				e = this.dict.wordSearch(text, false);
				break;
			case this.kanjiN:
				e = this.dict.kanjiSearch(text.charAt(0));
				break;
			case this.namesN:
				e = this.dict.wordSearch(text, true);
				break;
			}
			if (e) break;
			this.showMode = (this.showMode + 1) % this.dictCount;
		} while (this.showMode != m);

		if (!e) {
			this.hidePopup();
			this.clearHi();
			return -1;
		}
		this.lastFound = [e];

		if (!e.matchLen) e.matchLen = 1;
		tdata.uofsNext = e.matchLen;
		tdata.uofs = (ro - tdata.prevRangeOfs);

		// don't try to highlight form elements
		if ((this.cfg.highlight) && (!('form' in tdata.prevTarget))) {
			var doc = rp.ownerDocument;
			if (!doc) {
				this.clearHi();
				this.hidePopup();
				return 0;
			}
			this.highlightMatch(doc, rp, ro, e.matchLen, selEndList, tdata);
			tdata.prevSelView = doc.defaultView;
		}

		this.showPopup(this.dict.makeHtml(e), tdata.prevTarget, tdata.popX, tdata.popY, false);
		return 1;
	},

	highlightMatch: function (doc, rp, ro, matchLen, selEndList, tdata) {
		if (selEndList.length === 0) return;

		var selEnd;
		var offset = matchLen + ro;

		for (var i = 0, len = selEndList.length; i < len; i++) {
			selEnd = selEndList[i]
			if (offset <= selEnd.offset) break;
			offset -= selEnd.offset;
		}

		var range = doc.createRange();
		range.setStart(rp, ro);
		range.setEnd(selEnd.node, offset);

		var sel = doc.defaultView.getSelection();
		if ((!sel.isCollapsed) && (tdata.selText != sel.toString()))
			return;
		sel.removeAllRanges();
		sel.addRange(range);
		tdata.selText = sel.toString();
	},

	showTitle: function(tdata) {
		var e = this.dict.translate(tdata.title);
		if (!e) {
			this.hidePopup();
			return;
		}

		e.title = tdata.title.substr(0, e.textLen).replace(/[\x00-\xff]/g, function (c) { return '&#' + c.charCodeAt(0) + ';' } );
		if (tdata.title.length > e.textLen) e.title += '...';

		this.lastFound = [e];
		this.showPopup(this.dict.makeHtml(e), tdata.prevTarget, tdata.popX, tdata.popY, false);
	},
/*
	inRange: function (event) {
		var selection = event.view.getSelection();
		if ((selection.rangeCount === 0) || (!event.rangeParent)) return false;
		var newRange = event.view.document.createRange();
		newRange.setStart(event.rangeParent, event.rangeOffset);
		newRange.setEnd(event.rangeParent, event.rangeOffset);

		var curRange = selection.getRangeAt(0);
		if (newRange.compareBoundaryPoints(Range.START_TO_START, curRange) > -1 &&
			newRange.compareBoundaryPoints(Range.END_TO_END, curRange) < 0)
			return true;
		else return false;
	},
	
*/
	onMouseMove: function(ev) { peraMain._onMouseMove(ev); },
	_onMouseMove: function(ev) {
		var tdata = ev.currentTarget.perakun;	// per-tab data
		var rp = ev.rangeParent;
		var ro = ev.rangeOffset;

/*
		don't do anything if moving within the current selection
		if (this.cfg.highlight && this.inRange(ev)) return;
*/

		if (ev.target == tdata.prevTarget) {
			if (tdata.title) return;
			if ((rp == tdata.prevRangeNode) && (ro == tdata.prevRangeOfs)) return;
		}

		if (tdata.timer) {
			clearTimeout(tdata.timer);
			tdata.timer = null;
		}

		if ((ev.explicitOriginalTarget.nodeType != Node.TEXT_NODE) && !('form' in ev.target)) {
			rp = null;
			ro = -1;
		}

		tdata.prevTarget = ev.target;
		tdata.prevRangeNode = rp;
		tdata.prevRangeOfs = ro;
		tdata.title = null;
		tdata.uofs = 0;
		this.uofsNext = 1;

		if ((this.mouseButtons != 0) || (this.lbPop)) return;

		if ((rp) && (rp.data) && (ro < rp.data.length)) {
			this.showMode = ev.shiftKey ? 1 : 0;
			tdata.popX = ev.screenX;
			tdata.popY = ev.screenY;
			tdata.timer = Components.classes["@mozilla.org/timer;1"]
       						.createInstance(Components.interfaces.nsITimer)
       						.initWithCallback(function(){peraMain.show(tdata);},this.cfg.popdelay,0);
			return;
		}

		if (this.cfg.title) {
			if ((typeof(ev.target.title) == 'string') && (ev.target.title.length)) {
				tdata.title = ev.target.title;
			}
			else if ((typeof(ev.target.alt) == 'string') && (ev.target.alt.length)) {
				tdata.title = ev.target.alt;
			}
		}

		// FF3
		if (ev.target.nodeName == 'OPTION') {
			tdata.title = ev.target.text;
		}
		else if (ev.target.nodeName == 'SELECT') {
			tdata.title = ev.target.options[ev.target.selectedIndex].text;
		}

		if (tdata.title) {
			tdata.popX = ev.screenX;
			tdata.popY = ev.screenY;
			tdata.timer = Components.classes["@mozilla.org/timer;1"]
				.createInstance(Components.interfaces.nsITimer)
				.initWithCallback(function(){peraMain.showTitle(tdata);},this.cfg.popdelay,0);
		}
		else {
			// dont close just because we moved from a valid popup slightly over to a place with nothing
			var dx = tdata.popX - ev.screenX;
			var dy = tdata.popY - ev.screenY;
			var distance = Math.sqrt(dx * dx + dy * dy);
			if (distance > 4) {
				this.clearHi();
				this.hidePopup();
			}
		}

	},

	inlineEnable: function(bro, mode) {
		if(!this.dict)
			if (!this.loadDictionary()) 
				return;

		if (bro.perakun == null) {
			bro.perakun = {};
			this.mouseButtons = 0;
			bro.addEventListener('mousemove', this.onMouseMove, false);
			bro.addEventListener('mousedown', this.onMouseDown, false);
			bro.addEventListener('mouseup', this.onMouseUp, false);
			bro.addEventListener('keydown', this.onKeyDown, true);
			bro.addEventListener('keyup', this.onKeyUp, true);

			if (mode == 1) {
				this.showPopup(this.dict.miniHelp);

				if (peraMain.cfg.enmode > 0) {
					this.enabled = 1;
					if (peraMain.cfg.enmode == 2) {
						this.hiddenDOMWindow().perakun_active = 1;
						this.peraObs.notifyState('enable');
					}
				}
			}
		}
	},

	inlineDisable: function(bro, mode) {
		var e;

		bro.removeEventListener('mousemove', this.onMouseMove, false);
		bro.removeEventListener('mousedown', this.onMouseDown, false);
		bro.removeEventListener('mouseup', this.onMouseUp, false);
		bro.removeEventListener('keydown', this.onKeyDown, true);
		bro.removeEventListener('keyup', this.onKeyUp, true);

		e = bro.contentDocument.getElementById('perakun-css');
		if (e) e.parentNode.removeChild(e);
		e = bro.contentDocument.getElementById('perakun-window');
		if (e) e.parentNode.removeChild(e);

		this.clearHi();
		delete bro.perakun;

		if ((!this.isTB) && (this.enabled)) {
			this.enabled = 0;

			for (var i = 0; i < gBrowser.browsers.length; ++i) {
				this.inlineDisable(gBrowser.browsers[i], 0);
			}

			if ((peraMain.cfg.enmode == 2) && (mode == 1)) {
				this.hiddenDOMWindow().perakun_active = 0;
				this.peraObs.notifyState('disable');
			}
		}
		
		var b = document.getElementById('perakun-status');
		if (b) b.setAttribute('pera_lang', false);
		
		b = document.getElementById('perakun-toggle-button');
		if (b) b.setAttribute('pera_lang', false);
	},

	getSelected: function(win) {
		var text;
		var s = win.getSelection()
		if (s) {
			text = s.toString();
			if (text.search(/[^\s]/) != -1) return text;
		}
		for (var i = 0; i < win.frames.length; ++i) {
			text = this.getSelected(win.frames[i]);
			if (text.length > 0) return text;
		}
		return '';
	},

	clearSelected: function(win) {
		var s = win.getSelection();
		if (s) s.removeAllRanges();
		for (var i = 0; i < win.frames.length; ++i) {
			this.clearSelected(win.frames[i]);
		}
	},

	lbHide: function() {
		document.getElementById('perakun-lbar').hidden = true;
		this.hidePopup();
	},

	lbToggle: function() {
		var e;
		var h;
		var text;

		text = this.getSelected(window.content).substr(0, 30);
		this.lbText = document.getElementById('perakun-lbar-text');

		e = document.getElementById('perakun-lbar');
		if (e.hidden) {
			e.hidden = false;
		}
		else if (!this.lbText.getAttribute("focused")) {
			this.lbText.focus();
		}
		else if ((text.length == 0) || (text == this.lbLast)) {
			this.lbHide();
			return;
		}

		this.lbSearchButton();
	},

	lbKeyPress: function(ev) {
		switch (ev.keyCode) {
		case 13:
			this.lbSearch();
			ev.stopPropagation();
			break;
		case 27:
			if (this.isVisible()) this.hidePopup();
				else this.lbToggle();
			ev.stopPropagation();
			break;
		}
	},

	lbSearchButton: function() {
		var text;

		text = this.getSelected(window.content).substr(0, 30);
		if (text.length) {
			this.lbText.value = text;
			this.clearSelected(window.content);
		}

		this.lbSearch();

		this.lbText.select();
		this.lbText.focus();
	},

	lbSearch: function() {
		var names;
		var have;
		var html;
		var kanji;
		var s, t, e, i, c;

		s = this.lbText.value.replace(/^\s+/, '').replace(/\s+$/, '');
		if (!s.length) return;

		names = 0;
		if (this.haveNames) {
			if ((this.lbLast == s) && (this.isVisible())) {
				this.lbLast = '';
				names = 1;
			}
			else this.lbLast = s;
		}
		
		if (s.length == 0) {
			if(!this.loadDictionary())
				this.hidePopup();
		}
		else {
			html = kanji = '';

			// checkme: is this range ok?
			if ((s.search(/[:*\uFF0A]/) != -1) || (s.search(/^([^\u3000-\uFFFF]+)$/) != -1)) {
				t = s.replace(/;$/, '/')		// ; -> /
					.replace(/\uFF0A/, '*');	// J* -> *
				if ((e = this.dict.bruteSearch(t, names)) == null) {
					e = this.dict.bruteSearch(t, !names);
				}
			}
			else {
				if ((e = this.dict.wordSearch(s, names)) == null) {
					e = this.dict.wordSearch(s, !names);
				}
			}

			if (e) {
				html = this.dict.makeHtml(e);
				this.lastFound = [e];
			}
			else {
				html = '\u300C ' + s + ' \u300D was not found in the word' + ((this.haveNames) ? ' or name ' : '') + ' dictionary.';
				this.lastFound = [];
			}
			this.lastFound.fromLB = 1;

			have = {};
			t = s + html;
			for (i = 0; i < t.length; ++i) {
				c = t.charCodeAt(i);
				if ((c >= 0x3000) && (c <= 0xFFFF)) {
					c = t.charAt(i);
					if (!have[c]) {
						e = this.dict.kanjiSearch(c);
						if (e) {
							this.lastFound.push(e);
							have[c] = 1;
							kanji += '<td class="q-k">' + this.dict.makeHtml(e) + '</td>';
						}
					}
				}
			}

			this.showPopup('<table class="q-tb"><tr><td class="q-w">' + html + '</td>' + kanji + '</tr></table>', null, 1, 1, true, true);
		}
	},
	
	statusClick: function(ev) {
		//if (ev.button != 2) this.enableJapanese();
	},

	statusTimer: null,

	status: function(text) {
		/*
		if (this.statusTimer) {
			clearTimeout(this.statusTimer);
			this.statusTimer = null;
		}
		var e = document.getElementById('perakun-status-text');
		if (e) {
			e.setAttribute('label', text.substr(0, 80));
			e.setAttribute('hidden', 'false');
			this.statusTimer = Components.classes["@mozilla.org/timer;1"]
									.createInstance(Components.interfaces.nsITimer)
									.initWithCallback(function(e) { e.setAttribute('hidden', 'true') },2500,0);
		}
		*/
	},
	enableLanguage: function(language)
	{
		
		var bro = this.getCurrentBrowser();
		if(this.currentLanguage != null && this.currentLanguage == language)
		{
			if (bro.perakun)
				this.inlineDisable(bro, 1);
			else
				this.inlineEnable(bro, 1);
		}
		else
		{
			if(this.dict)
			{
				this.dict.unlock();
				this.dict = null;
				delete this.dict;
			}
			if(this.currentLanguage != null)
				this.inlineDisable(bro, 1);
			this.currentLanguage = language;
			this.inlineEnable(bro, 1);
		}
		this.onTabSelect();
	},
		
	disableLanguage: function()
	{
		var bro = this.getCurrentBrowser();
		if (bro.perakun)
		{
			if(this.dict)
			{
				this.dict.unlock();
				this.dict = null;
				delete this.dict;
			}
			var b = document.getElementById('perakun-status');
			if (b) b.setAttribute('pera_lang', false);
			
			b = document.getElementById('perakun-toggle-button');
			if (b) b.setAttribute('pera_lang', false);
			
			this.inlineDisable(bro, 1);
		}
	},
	
	gotoHomepage: function()
	{
		var url = 'http://perapera.wordpress.com';

		if (this.isTB) {
			Components.classes['@mozilla.org/messenger;1'].createInstance()
				.QueryInterface(Components.interfaces.nsIMessenger)
				.launchExternalURL(url);
		}
		else {
			var w = window.open(url, 'peraperakun');
			if (w) w.focus();
		}
	},
	
	showingMenuPopup: function(evt)
	{
		var menu = "";
		if(evt.target.id == 'perakun-popup-toolsmenu')
			menu = "toolsmenu";
		else if (evt.target.id == 'perakun-popup-context')
			menu = "context";
		else
			return;
			
		var bro = this.getCurrentBrowser();
		if(bro.perakun) //enabled
		{
			document.getElementById("perakun-" + menu + "-toggle").setAttribute('hidden', true);
			document.getElementById("perakun-" + menu + "-chinese").setAttribute('hidden', true);
			document.getElementById("perakun-" + menu + "-japanese").setAttribute('hidden', true);
			document.getElementById("perakun-" + menu + "-korean").setAttribute('hidden', true);
			
			document.getElementById("perakun-" + menu + "-disable").setAttribute('hidden', false);
			
		}
		else //disabled show full menu
		{
			document.getElementById("perakun-" + menu + "-disable").setAttribute('hidden', true);
			if(this.enabledLangs.chn)
			{
				var chineseItem = document.getElementById("perakun-" + menu + "-chinese"); 
				chineseItem.setAttribute('hidden', false);
				if(this.getPrefBranch().getBoolPref('safeflag') == true)
					chineseItem.setAttribute('class', 'perakun-flag-chinesesafe');
				else
					chineseItem.setAttribute('class', 'perakun-flag-chinese');
				
			}
			else
				document.getElementById("perakun-" + menu + "-chinese").setAttribute('hidden', true);
				
			document.getElementById("perakun-" + menu + "-japanese").setAttribute('hidden', !this.enabledLangs.jap);
			document.getElementById("perakun-" + menu + "-korean").setAttribute('hidden', !this.enabledLangs.kor);
		}
	},
	
	ppkIconClicked: function(evt)
	{
		if(evt.button == 0) //left click
		{
			var installCount = 0;
			installCount += this.enabledLangs.jap == true ? 1 : 0;
			installCount += this.enabledLangs.kor == true ? 1 : 0;
			installCount += this.enabledLangs.chn == true ? 1 : 0;
			
			var bro = this.getCurrentBrowser();		
			if(!bro.perakun) //nothing is enabled so show popup or toggle
			{
				if(installCount > 1)
				{
					if(evt.target.id == "perakun-status")
					{
						var popup = document.getElementById('perakun-statusbar-menu');
						var button = document.getElementById('perakun-status');
						if (this.enabledLangs.chn == true && this.getPrefBranch().getBoolPref('safeflag') == true)
							document.getElementById('perakun-status-cflag').setAttribute('flag', "safe");
						else
							document.getElementById('perakun-status-cflag').setAttribute('flag', "default");
						popup.openPopup( button , "before_end", 0, 0, false, false);
					}
					else if (evt.target.id == "perakun-toggle-button") 
					{
						var popup = document.getElementById('perakun-toolbar-menu');
						var button = document.getElementById('perakun-toggle-button');
						if (this.enabledLangs.chn == true && this.getPrefBranch().getBoolPref('safeflag') == true)
							document.getElementById('perakun-tbar-cflag').setAttribute('flag', "safe");
						else
							document.getElementById('perakun-tbar-cflag').setAttribute('flag', "default");
						popup.openPopup( button , "after_end", 0, 0, false, false);
					}
				}
				else //only 1 language so toggle it
				{
					if(this.enabledLangs.chn)
						this.enableLanguage(Languages.Chinese)
					else if (this.enabledLangs.jap)
						this.enableLanguage(Languages.Japanese)
					else if (this.enabledLangs.kor)
						this.enableLanguage(Languages.Korean)
				}	
			}
			else //already enabled
			{
				this.inlineDisable(bro, 1);
			}
		}
	}
};

///

peraMain.init();

//switch langauge
/*
switch(currentLanguage)
{
	case Languages.Chinese:
	break;
	case Languages.Japanese:
	break;
	
}
 */

/*
rcd_con('**RIKAICHAN DEBUG**');

function rcd_con(msg)
{
	Components.classes['@mozilla.org/consoleservice;1']
		.getService(Components.interfaces.nsIConsoleService)
		.logStringMessage(msg);
//	toJavaScriptConsole();
}

function rcd_status(s)
{
	if (typeof(rcd_status_timeout) != 'undefined') {
		clearTimeout(rcd_status_timeout);
		rcd_status_timeout = undefined;
	}

	var e = document.getElementById('perakun-status-text');
	if ((s) && (s.length)) {
		e.setAttribute('label', s.substr(0, 80));
		e.setAttribute('hidden', 'false');
		
	}
	else {
		e.setAttribute('hidden', 'true');
	}
}

function rcd_dumo(o)
{
	var k;
	var s = '[' + o + ']\r\n';
	for (k in o) {
		try {
			s += k + '=' + String(o[k]).replace(/[\r\n\t]/g, ' ') + '\r\n';
		}
		catch (err) {
			s += err + '\r\n';
		}
	}
	rcd_con(s);
}

function rcd_clip(s) {
	Components.classes['@mozilla.org/widget/clipboardhelper;1']
		.getService(Components.interfaces.nsIClipboardHelper)
		.copyString(s);
}
/**/


/*
	2E80 - 2EFF	CJK Radicals Supplement
	2F00 - 2FDF	Kangxi Radicals
	2FF0 - 2FFF	Ideographic Description
p	3000 - 303F CJK Symbols and Punctuation
x	3040 - 309F Hiragana
x	30A0 - 30FF Katakana
	3190 - 319F	Kanbun
	31F0 - 31FF Katakana Phonetic Extensions
	3200 - 32FF Enclosed CJK Letters and Months
	3300 - 33FF CJK Compatibility
x	3400 - 4DBF	CJK Unified Ideographs Extension A
x	4E00 - 9FFF	CJK Unified Ideographs
x	F900 - FAFF	CJK Compatibility Ideographs
p	FF00 - FFEF Halfwidth and Fullwidth Forms
x	FF66 - FF9D	Katakana half-width

*/
