/*
	Perapera-kun
	Justin Kovalchuk
	http://perapera.wordpress.com/
	
	---
	
	Based on Rikaichan by Jonathan Zarate
	Copyright (C) 2005-2009 
	http://www.polarcloud.com/
	
	---

	This program is free software; you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation; either version 2 of the License, or
	(at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

	---

	Please do not change or remove any of the copyrights or links to web pages
	when modifying any of the files. - Jon

*/
var HanziDisplay = {"OnlySimplified" : 0, "OnlyTraditional" : 1, "AsDisplayed" : 2, "Both" : 3};

var peraPrefs = {
	// kill the lbar funcs: ['toggle', 'lbar'],
	funcs: ['toggle'],
	modifiers: ['accel', 'alt', 'shift'],
	keys: ['(disabled)',
		'0','1','2','3','4','5','6','7','8','9','A','B','C','D','E','F','G','H','I','J','K',
		'L','M','N','O','P','Q','R','S','T','U','V','W','X','Y','Z','Back','Escape','Page Up',
		'Page Down','End','Home','Left','Up','Right','Down','Insert','Delete','F1','F2','F3',
		'F4','F5','F6','F7','F8','F9','F10','F11','F12'],
	kindex: ['COMP', 'H','L','E','DK','N','V','Y','P','IN','I','U'],

	checkRange: function(e, name, min, max) {
		e = document.getElementById(e);
		var v = e.value;
		if ((isNaN(v)) || (v < min) || (v > max)) {
			e.focus();
			alert('Invalid ' + name + ' (' + v + '). Valid range: ' + min + '-' + max);
			return false;
		}
		return true;
	},

	onLoad: function() {
		try{
			if (navigator.userAgent.search(/thunderbird|shredder/i) != -1) {
				document.getElementById('pkp-enmode-hbox').hidden = true;
			}

			var pb = Components
					.classes['@mozilla.org/preferences-service;1']
					.getService(Components.interfaces.nsIPrefService)
					.getBranch('perakun.');

			var i, e, v;

			for (i = 0; i < this.funcs.length; ++i) {
				var fu = this.funcs[i];

				v = pb.getCharPref(fu + '.mod');
				for (var j = 0; j < this.modifiers.length; ++j) {
					var mo = this.modifiers[j];
					document.getElementById('pkp-' + fu + '-' + mo).checked = (v.indexOf(mo) != -1);
				}

				e = document.getElementById('pkp-' + fu + '-list');
				for (var j = 0; j < this.keys.length; ++j) {
					v = document.createElementNS('http://www.mozilla.org/keymaster/gatekeeper/there.is.only.xul', 'menuitem');
					v.setAttribute('label', this.keys[j]);
					e.appendChild(v);
				}

				v = pb.getCharPref(fu + '.key');
				if (v.length == 0) v = this.keys[0];
				e = document.getElementById('pkp-' + fu + '-key');
				e.value = v;
				this.onKeyChanged(e);
			}

			v = pb.getCharPref('kindex').split(',');
			for (i = 0; i < v.length; ++i) {
				if ((e = document.getElementById('pkp-kindex-' + v[i])) != null) {
					e.checked = true;
				}
			}

			for (i = 0; i < peraCfgList.length; ++i) {
				var cfg = peraCfgList[i];
				e = document.getElementById('pkp-' + cfg[1]);
				if (!e) continue;
				
				if(cfg[1] == "ssep")
				{
					var ssepVal = pb.getCharPref(cfg[1]);
					if( ssepVal == "edict") 
					{
						document.getElementById('ppk-outformat').selectedIndex = 1;
						document.getElementById("pkp-ssep").disabled = true;
					}
					else
					{
						document.getElementById('ppk-outformat').selectedIndex = 0;
						e.value = ssepVal; 
					}
					continue;
				}
				switch (cfg[0]) {
				case 0:
					e.value = pb.getIntPref(cfg[1]);
					break;
				case 1:
					e.value = pb.getCharPref(cfg[1]);
					break;
				case 2:
					e.checked = pb.getBoolPref(cfg[1]);
					break;
				case 3:
					e.selectedIndex = pb.getIntPref(cfg[1]);
					break;
				}
			}

			//chinese
			if(pb.getBoolPref('chinese_installed'))
			{
				document.getElementById("ppk-chinese-tab").disabled = false;
				if(pb.getBoolPref('chinese_enabled'))
					document.getElementById('perakun-chinese').setAttribute('dict_enabled', true);
				if(pb.getBoolPref('safeflag'))
					document.getElementById('perakun-chinese').setAttribute('flag', 'safe');
			}
			else
				document.getElementById("ppk-chinese-tab").disabled = true;

			//japanese	
			if(pb.getBoolPref('japanese_installed'))
			{
				document.getElementById("ppk-japanese-tab").disabled = false;
				if(pb.getBoolPref('japanese_enabled'))
					document.getElementById('perakun-japanese').setAttribute('dict_enabled', true);
			}
			else
				document.getElementById("ppk-japanese-tab").disabled = true;

			//korean
			if(pb.getBoolPref('korean_installed'))
			{
				document.getElementById("ppk-korean-tab").disabled = false;
				if(pb.getBoolPref('korean_enabled'))
					document.getElementById('perakun-korean').setAttribute('dict_enabled', true);
			}
			else
				document.getElementById("ppk-korean-tab").disabled = true;
		}
		catch (ex) {
			alert('Exception: ' + ex);
		}
	},

	onOK: function() {
		try {
			//if (!this.checkRange('pkp-popdelay', 'Popup Delay', 1, 2000)) return false;
			if (!this.checkRange('pkp-wmax', 'Maximum Entries To Display', 3, 100)) return false;
			if (!this.checkRange('pkp-namax', 'Maximum Entries To Display', 3, 200)) return false;

			var pb = Components
					.classes['@mozilla.org/preferences-service;1']
					.getService(Components.interfaces.nsIPrefService)
					.getBranch('perakun.');

			var i;

			for (i = 0; i < this.funcs.length; ++i) {
				var fu = this.funcs[i];

				var m = [];
				for (var j = 0; j < this.modifiers.length; ++j) {
					var mo = this.modifiers[j];
					if (document.getElementById('pkp-' + fu + '-' + mo).checked) m.push(mo);
				}
				pb.setCharPref(fu + '.mod', m.join(' '));

				var key = document.getElementById('pkp-' + fu + '-key').value;
				pb.setCharPref(fu + '.key', (key == '(disabled)') ? '' : key);
			}

			var v = [];
			for (i = 0; i < this.kindex.length; ++i) {
				if (document.getElementById('pkp-kindex-' + this.kindex[i]).checked)
					v.push(this.kindex[i]);
			}
			pb.setCharPref('kindex', v.join(','));

			for (i = 0; i < peraCfgList.length; ++i) {
				var cfg = peraCfgList[i];
				var e = document.getElementById('pkp-' + cfg[1]);
				if (!e) continue;
				
				if(cfg[1] == "ssep")
				{
					if( document.getElementById('ppk-outformat').selectedIndex == 0 ) //delimited
						pb.setCharPref(cfg[1], e.value);
					else
						pb.setCharPref(cfg[1], "edict");
					continue;
				}
				switch (cfg[0]) {
				case 0:
					pb.setIntPref(cfg[1], e.value);
					break;
				case 1:
					pb.setCharPref(cfg[1], e.value);
					break;
				case 2:
					pb.setBoolPref(cfg[1], e.checked);
					break;
				case 3:
					pb.setIntPref(cfg[1], e.selectedIndex);
					break;
				}
			}

			return true;
		}
		catch (ex) {
			alert('Exception: ' + ex);
		}

		return false;
	},

	onKeyChanged: function(e) {
		var v = e.value.replace(/^\s+|\s+$/g, '').replace(/\s+/g, ' ');
		e.value = v;
		v = ((v.length == 0) || (v == '(disabled)'));
		for (var j = 0; j < this.modifiers.length; ++j) {
			document.getElementById(e.id.replace('key', this.modifiers[j])).disabled = v;
		}
	},

	browseFile: function(id) {
		const nsIFilePicker = Components.interfaces.nsIFilePicker;
		var fp = Components.classes['@mozilla.org/filepicker;1'].createInstance(nsIFilePicker);

		fp.init(window, 'Browse', nsIFilePicker.modeSave);
		fp.appendFilters(nsIFilePicker.filterAll | nsIFilePicker.filterText);
		fp.defaultString = document.getElementById(id).value;

		var r = fp.show();
		if ((r == nsIFilePicker.returnOK) || (r == nsIFilePicker.returnReplace))
		  document.getElementById(id).value = fp.file.path;
	},
	
	donate: function()
	{
		var docID = document.documentElement.id;
		var isTB = ((docID == "messengerWindow") || (docID == "msgcomposeWindow"));
			
		var url = 'https://www.paypal.com/cgi-bin/webscr?cmd=_donations&business=jkaccounts@gmail.com&item_name=Perapera-kun%20Language%20Project&page_style=PayPal&no_shipping=1&currency_code=USD&tax=0&lc=US';
		if (isTB) {
			Components.classes['@mozilla.org/messenger;1'].createInstance()
				.QueryInterface(Components.interfaces.nsIMessenger)
				.launchExternalURL(url);
		}
		else {
			var w = window.open(url, 'peraperakun');
			if (w) w.focus();
		}
	},
	
	outputRadioChanged: function()
	{
		if( document.getElementById("ppk-outformat").selectedIndex == 0) //delimited
			document.getElementById("pkp-ssep").disabled = false;
		else if( document.getElementById("ppk-outformat").selectedIndex == 1) //edict
			document.getElementById("pkp-ssep").disabled = true;
	},
	
	toggleLanguage: function(language)
	{
		var url;
		var pb = Components
			.classes['@mozilla.org/preferences-service;1']
			.getService(Components.interfaces.nsIPrefService)
			.getBranch('perakun.');
			
		switch(language)
		{
			case 0: //japanese
				if(pb.getBoolPref('japanese_installed') == false)
				{
					this.showDownload(1);
					return;
				}
				var pref = pb.getBoolPref('japanese_enabled');
				pb.setBoolPref('japanese_enabled', !pref);
				document.getElementById('perakun-japanese').setAttribute('dict_enabled', !pref);
			break;

			case 1: //chinese
				if(pb.getBoolPref('chinese_installed') == false)
				{
					this.showDownload(0);
					return;
				}
				var pref = pb.getBoolPref('chinese_enabled');
				pb.setBoolPref('chinese_enabled', !pref);
				document.getElementById('perakun-chinese').setAttribute('dict_enabled', !pref);
			break;

			case 2: //korean
				if(pb.getBoolPref('korean_installed') == false)
				{
					this.showDownload(2);
					return;
				}
				var pref = pb.getBoolPref('korean_enabled');
				pb.setBoolPref('korean_enabled', !pref);
				document.getElementById('perakun-korean').setAttribute('dict_enabled', !pref);
			break;
			
			default:
				return;
			break;
		}
	},
	
	showDownload: function(language)
	{
		switch(language)
		{
			case 0: //chinese
				url = 'http://perapera.wordpress.com/chinese/';
			break;

			case 1: //japanese
				url = 'http://perapera.wordpress.com/perapera-kun/';
			break;

			case 2: //korean
				url = 'http://perapera.wordpress.com/korean/';
			break;
			
			default:
				return;
			break;
		}
		if (this.isTB) {
			Components.classes['@mozilla.org/messenger;1'].createInstance()
				.QueryInterface(Components.interfaces.nsIMessenger)
				.launchExternalURL(url);
		}
		else {
			var w = window.open(url, 'peraperakun');
			if (w) w.focus();
		}
	}
};
